<?php
// Copyright (C) <2015-present>  <it-novum GmbH>
//
// This file is licensed under the terms of the openITCOCKPIT Enterprise Edition license agreement.
// The license agreement and license key were sent with the order confirmation.

namespace MapModule\Controller;

use Cake\Http\Exception\MethodNotAllowedException;
use Cake\Http\Exception\NotFoundException;
use Cake\ORM\TableRegistry;
use Cake\Utility\Hash;
use Exception;
use itnovum\openITCOCKPIT\Core\AngularJS\Api;
use itnovum\openITCOCKPIT\Database\PaginateOMat;
use itnovum\openITCOCKPIT\Filter\MapFilter;
use itnovum\openITCOCKPIT\Filter\RotationFilter;
use MapModule\Model\Table\MapsTable;
use MapModule\Model\Table\RotationsTable;

class RotationsController extends AppController {

    public function index() {
        if (!$this->isApiRequest()) {
            //Only ship template for AngularJs
            return;
        }

        /** @var RotationsTable $RotationsTable */
        $RotationsTable = TableRegistry::getTableLocator()->get('MapModule.Rotations');

        $RotationFilter = new RotationFilter($this->request);
        $PaginateOMat = new PaginateOMat($this, $this->isScrollRequest(), $RotationFilter->getPage());

        $limit = $PaginateOMat->getHandler()->getLimit();
        $Paginator = null;
        if ($this->isApiRequest() && !$this->isAngularJsRequest()) {
            $limit = null;
        } else {
            $Paginator = $PaginateOMat;
        }

        $all_rotations = $RotationsTable->getAll(
            $RotationFilter->indexFilter(),
            $RotationFilter->getOrderForPaginator('Rotations.name', 'asc'),
            $limit,
            $Paginator,
            []);

        //build rotation link
        foreach ($all_rotations as $key => $rotation) {
            $all_rotations[$key]['ids'] = [];
            foreach ($rotation['maps'] as $rKey => $map) {
                if (!isset($all_rotations[$key]['first_id'])) {
                    $all_rotations[$key]['first_id'] = $map['id'];
                }
                $all_rotations[$key]['ids'][] = $map['id'];
            }
            $all_rotations[$key]['ids'] = implode(',', $all_rotations[$key]['ids']);
        }

        $this->set('all_rotations', $all_rotations);
        $this->viewBuilder()->setOption('serialize', ['all_rotations', 'paging']);
    }
}
