<?php
// Copyright (C) <2015-present>  <it-novum GmbH>
//
// This file is licensed under the terms of the openITCOCKPIT Enterprise Edition license agreement.
// The license agreement and license key were sent with the order confirmation.

namespace App\Authenticator;

use Authentication\Authenticator\AbstractAuthenticator;
use Authentication\Authenticator\Result;
use Authentication\Authenticator\ResultInterface;
use Psr\Http\Message\ServerRequestInterface;

class SslAuthenticator extends AbstractAuthenticator {

    /**
     * Authenticate a user based on the request information.
     *
     * @param ServerRequestInterface $request Request to get authentication information from.
     * @return ResultInterface Returns a result object.
     */
    public function authenticate(ServerRequestInterface $request): ResultInterface {

        $data = [];
        $user = $this->_identifier->identify($data);

        if (empty($user)) {
            return new Result(null, Result::FAILURE_IDENTITY_NOT_FOUND, $this->_identifier->getErrors());
        }

        return new Result($user, Result::SUCCESS);
    }

}
