<?php
/**
 * CakePHP(tm) : Rapid Development Framework (http://cakephp.org)
 * Copyright (c) Cake Software Foundation, Inc. (http://cakefoundation.org)
 *
 * Licensed under The MIT License
 * For full copyright and license information, please see the LICENSE.txt
 * Redistributions of files must retain the above copyright notice.
 *
 * @copyright     Copyright (c) Cake Software Foundation, Inc. (http://cakefoundation.org)
 * @link          http://cakephp.org CakePHP(tm) Project
 * @since         3.3.4
 * @license       http://www.opensource.org/licenses/mit-license.php MIT License
 */

namespace App\Controller;

use Cake\Event\EventInterface;
use Cake\Http\Response;

/**
 * Error Handling Controller
 *
 * Controller used by ExceptionRenderer to render error responses.
 */
class ErrorController extends AppController {
    /**
     * Initialization hook method.
     *
     * @return void
     */
    public function initialize(): void {
        $this->loadComponent('RequestHandler');
    }

    /**
     * beforeFilter callback.
     *
     * @param EventInterface $event Event.
     * @return Response|null|void
     */
    public function beforeFilter(EventInterface $event) {
    }

    /**
     * beforeRender callback.
     *
     * @param EventInterface $event Event.
     * @return Response|null|void
     */
    public function beforeRender(EventInterface $event) {
        parent::beforeRender($event);

        $this->viewBuilder()->setTemplatePath('Error');
    }

    /**
     * afterFilter callback.
     *
     * @param EventInterface $event Event.
     * @return Response|null|void
     */
    public function afterFilter(EventInterface $event) {
    }
}
