<?php
// Copyright (C) <2015-present>  <it-novum GmbH>
//
// This file is licensed under the terms of the openITCOCKPIT Enterprise Edition license agreement.
// The license agreement and license key were sent with the order confirmation.
declare(strict_types=1);

namespace App\Controller;

use App\Filter\ServicecheckFilter;
use App\Model\Entity\Servicecheck;
use App\Model\Table\ServicechecksTable;
use Cake\Http\Response;
use Cake\ORM\TableRegistry;
use itnovum\openITCOCKPIT\Core\Views\UserTime;
use itnovum\openITCOCKPIT\Database\PaginateOMat;

/**
 * Class ServicechecksController
 * @package App\Controller
 */
class ServicechecksController extends AppController {

    public function index() {
        if (!$this->isApiRequest()) {
            //Only ship the template for .html requests
            return;
        }

        /** @var ServicechecksTable $ServicechecksTable */
        $ServicechecksTable = TableRegistry::getTableLocator()->get('Servicechecks');

        $serviceCheckFilter = new ServicecheckFilter($this->request);
        $PaginateOMat = new PaginateOMat($this, $this->isScrollRequest(), $serviceCheckFilter->getPage());

        $UserTime = UserTime::fromUser($this->getUser());

        $servicechecks = $ServicechecksTable->getServiceChecks($serviceCheckFilter, $PaginateOMat);
        foreach ($servicechecks as $index => $servicecheck) {
            /** @var Servicecheck $servicecheck */
            $servicecheck->setUserTime($UserTime);
        }


        $this->set('servicechecks', $servicechecks);
        $this->viewBuilder()->setOption('serialize', ['servicechecks', 'paging']);
    }
}
