<?php
// Copyright (C) <2015-present>  <it-novum GmbH>
//
// This file is licensed under the terms of the openITCOCKPIT Enterprise Edition license agreement.
// The license agreement and license key were sent with the order confirmation.
declare(strict_types=1);

namespace App\Controller;

use App\Filter\HostStatehistoryFilter;
use App\Filter\ServiceStatehistoryFilter;
use App\Model\Entity\HostStatehistory;
use App\Model\Entity\ServiceStatehistory;
use App\Model\Table\HostStatehistoryTable;
use App\Model\Table\ServiceStatehistoryTable;
use Cake\ORM\TableRegistry;
use itnovum\openITCOCKPIT\Core\Views\UserTime;
use itnovum\openITCOCKPIT\Database\PaginateOMat;

/**
 * Class StatehistoriesController
 * @package App\Controller
 */
class StatehistoriesController extends AppController {

    public function host() {
        if (!$this->isApiRequest()) {
            //Only ship the template for .html requests
            return;
        }

        /** @var HostStatehistoryTable $HostStatehistoryTable */
        $HostStatehistoryTable = TableRegistry::getTableLocator()->get('HostStatehistory');

        $HostStateHistoryFilter = new HostStatehistoryFilter($this->request);
        $PaginateOMat = new PaginateOMat($this, $this->isScrollRequest(), $HostStateHistoryFilter->getPage());

        $UserTime = UserTime::fromUser($this->getUser());

        $hoststateHistory = $HostStatehistoryTable->getHostStateHistory($HostStateHistoryFilter, $PaginateOMat);

        foreach ($hoststateHistory as $index => $entity) {
            /** @var HostStatehistory $entity */
            $entity->setUserTime($UserTime);
        }

        $this->set('hoststatehistory', $hoststateHistory);
        $this->viewBuilder()->setOption('serialize', ['hoststatehistory']);
    }

    public function service() {
        if (!$this->isApiRequest()) {
            //Only ship the template for .html requests
            return;
        }

        /** @var ServiceStatehistoryTable $ServiceStatehistoryTable */
        $ServiceStatehistoryTable = TableRegistry::getTableLocator()->get('ServiceStatehistory');

        $ServiceStatehistoryFilter = new ServiceStatehistoryFilter($this->request);
        $PaginateOMat = new PaginateOMat($this, $this->isScrollRequest(), $ServiceStatehistoryFilter->getPage());

        $UserTime = UserTime::fromUser($this->getUser());

        $servicestatehistory = $ServiceStatehistoryTable->getServiceStateHistory($ServiceStatehistoryFilter, $PaginateOMat);
        foreach ($servicestatehistory as $index => $entity) {
            /** @var ServiceStatehistory $entity */
            $entity->setUserTime($UserTime);
        }

        $this->set('servicestatehistory', $servicestatehistory);
        $this->viewBuilder()->setOption('serialize', ['servicestatehistory']);
    }
}
