<?php
// Copyright (C) <2015-present>  <it-novum GmbH>
//
// This file is licensed under the terms of the openITCOCKPIT Enterprise Edition license agreement.
// The license agreement and license key were sent with the order confirmation.

namespace App\Model\Entity;

use Cake\ORM\Entity;
use itnovum\openITCOCKPIT\Core\Views\UserTime;

/**
 * HostStatehistory Entity
 *
 * @property string $hostname
 * @property int $state_time
 * @property bool $state_change
 * @property bool $state
 * @property bool $is_hardstate
 * @property int $current_check_attempt
 * @property int $max_check_attempts
 * @property bool $last_state
 * @property bool $last_hard_state
 * @property string $output
 * @property string $long_output
 */
class HostStatehistory extends Entity {

    /**
     * @var UserTime|null
     */
    private $UserTime = null;

    /**
     * @param UserTime $UserTime
     */
    public function setUserTime(UserTime $UserTime) {
        $this->UserTime = $UserTime;
    }

    /**
     * @return array
     */
    public function jsonSerialize(): array {
        if ($this->UserTime === null) {
            return parent::jsonSerialize();
        }

        $data = parent::jsonSerialize();
        $fields = [
            'state_time'
        ];

        foreach ($fields as $field) {
            if (isset($data[$field])) {
                $data[$field] = $this->UserTime->format($data[$field]);
            }
        }

        return $data;
    }

}
