<?php
// Copyright (C) <2015-present>  <it-novum GmbH>
//
// This file is licensed under the terms of the openITCOCKPIT Enterprise Edition license agreement.
// The license agreement and license key were sent with the order confirmation.

namespace App\Model\Table;

use App\Filter\ServiceStatehistoryFilter;
use App\Lib\Traits\PaginationAndScrollIndexTrait;
use App\Model\Entity\ServiceStatehistory;
use Cake\Datasource\EntityInterface;
use Cake\ORM\RulesChecker;
use Cake\ORM\Table;
use Cake\Validation\Validator;
use itnovum\openITCOCKPIT\Database\PaginateOMat;

/**
 * ServiceStatehistory Model
 *
 * @method ServiceStatehistory get($primaryKey, $options = [])
 * @method ServiceStatehistory newEntity($data = null, array $options = [])
 * @method ServiceStatehistory[] newEntities(array $data, array $options = [])
 * @method ServiceStatehistory|bool save(EntityInterface $entity, $options = [])
 * @method ServiceStatehistory patchEntity(EntityInterface $entity, array $data, array $options = [])
 * @method ServiceStatehistory[] patchEntities($entities, array $data, array $options = [])
 * @method ServiceStatehistory findOrCreate($search, callable $callback = null, $options = [])
 */
class ServiceStatehistoryTable extends Table {
    use PaginationAndScrollIndexTrait;

    /**
     * Initialize method
     *
     * @param array $config The configuration for the Table.
     * @return void
     */
    public function initialize(array $config): void {
        parent::initialize($config);

        $this->setTable('statusengine_service_statehistory');
    }

    /**
     * Default validation rules.
     *
     * @param \Cake\Validation\Validator $validator Validator instance.
     * @return \Cake\Validation\Validator
     */
    public function validationDefault(Validator $validator): Validator {
        //Readonly table
        return $validator;
    }

    /**
     * Returns a rules checker object that will be used for validating
     * application integrity.
     *
     * @param \Cake\ORM\RulesChecker $rules The rules object to be modified.
     * @return \Cake\ORM\RulesChecker
     */
    public function buildRules(RulesChecker $rules): RulesChecker {
        //Readonly table
        return $rules;
    }

    public function getServiceStateHistory(ServiceStatehistoryFilter $ServiceStatehistoryFilter, PaginateOMat $PaginateOMat) {
        $query = $this->find()
            ->where($ServiceStatehistoryFilter->indexFilter())
            ->order($ServiceStatehistoryFilter->getOrderForPaginator('ServiceStatehistory.state_time', 'desc'));

        if ($PaginateOMat === null) {
            //Just execute query
            $result = $query->toArray();
        } else {
            if ($PaginateOMat->useScroll()) {
                $result = $this->scrollCake4($query, $PaginateOMat->getHandler());
            } else {
                $result = $this->paginateCake4($query, $PaginateOMat->getHandler());
            }
        }

        return $result;
    }
}
