<?php
// Copyright (C) <2015-present>  <it-novum GmbH>
//
// This file is licensed under the terms of the openITCOCKPIT Enterprise Edition license agreement.
// The license agreement and license key were sent with the order confirmation.
?>
<ol class="breadcrumb page-breadcrumb">
    <li class="breadcrumb-item">
        <a ui-sref="DashboardsIndex">
            <i class="fa fa-home"></i> <?php echo __('Home'); ?>
        </a>
    </li>
    <li class="breadcrumb-item">
        <a ui-sref="AgentconnectorsPull">
            <i class="fa fa-user-secret"></i> <?php echo __('openITCOCKPIT Agent'); ?>
        </a>
    </li>
    <li class="breadcrumb-item">
        <i class="fa-solid fa-wand-magic-sparkles"></i> <?php echo __('Overview'); ?>
    </li>
</ol>

<div class="alert alert-info alert-dismissible fade show" role="alert">
    <button type="button" class="close" data-dismiss="alert" aria-label="Close">
        <span aria-hidden="true"><i class="fas fa-times"></i></span>
    </button>
    <div class="d-flex align-items-center">
        <div class="alert-icon width-3">
            <div class="icon-stack icon-stack-sm">
                <i class="fa-solid fa-circle-info opacity-100"></i>
            </div>
        </div>
        <div class="flex-1">
            <span class="h5 m-0 fw-700"><?= __('Notice'); ?>:</span>
            <?= __('This view has limited features due to the data is loaded from the configuration files instead of a database.'); ?>
        </div>
    </div>
</div>

<div class="row">
    <div class="col-xl-12">
        <div id="panel-1" class="panel">
            <div class="panel-hdr">
                <h2>
                    <?php echo __('Agents overview'); ?>
                    <span class="fw-300"><i><?php echo __('Pull mode'); ?></i></span>
                </h2>

                <div class="panel-toolbar">
                    <ul class="nav nav-tabs border-bottom-0 nav-tabs-clean" role="tablist">
                        <?php if ($this->Acl->hasPermission('overview', 'agentconnector')): ?>
                            <li class="nav-item">
                                <a class="nav-link active" data-toggle="tab" ui-sref="AgentconnectorsPull" role="tab">
                                    <i class="fas fa-download"></i>&nbsp;
                                    <?php echo __('Pull'); ?>
                                </a>
                            </li>
                        <?php endif; ?>
                        <?php if ($this->Acl->hasPermission('overview', 'agentconnector')): ?>
                            <li class="nav-item">
                                <a class="nav-link" data-toggle="tab" ui-sref="AgentconnectorsPush" role="tab">
                                    <i class="fas fa-upload"></i>&nbsp;
                                    <?php echo __('Push'); ?>
                                </a>
                            </li>
                        <?php endif; ?>
                    </ul>
                    <button class="btn btn-xs btn-default mr-1 shadow-0" ng-click="load()">
                        <i class="fas fa-sync"></i> <?php echo __('Refresh'); ?>
                    </button>
                </div>
            </div>
            <div class="panel-container show">
                <div class="panel-content">

                    <div class="frame-wrap">
                        <table class="table table-striped m-0 table-bordered table-hover table-sm">
                            <thead>
                            <tr>
                                <th class="no-sort">
                                    <?php echo __('Host name'); ?>
                                </th>
                                <th class="no-sort">
                                    <?php echo __('Port'); ?>
                                </th>
                                <th class="no-sort">
                                    <?php echo __('Connection type'); ?>
                                </th>
                            </tr>
                            </thead>

                            <tbody>
                            <tr ng-repeat="agent in agents">
                                <td>
                                    <?php if ($this->Acl->hasPermission('browser', 'hosts')): ?>
                                        <a ui-sref="HostsBrowser({uuid:agent.host.uuid})">
                                            {{ agent.host.name }}
                                        </a>
                                    <?php else: ?>
                                        {{ agent.host.name }}
                                    <?php endif; ?>
                                </td>
                                <td>
                                    {{ agent.port}}
                                </td>
                                <td>
                                    <span class="badge badge-success"
                                          ng-show="agent.use_https && !agent.insecure">
                                        <?php echo __('HTTPS'); ?>
                                    </span>
                                    <span class="badge badge-warning"
                                          ng-show="agent.use_https && agent.insecure">
                                        <?php echo __('HTTPS (insecure)'); ?>
                                    </span>
                                    <span class="badge badge-success"
                                          ng-show="agent.use_autossl">
                                        <?php echo __('Auto-TLS'); ?>
                                    </span>
                                    <span class="badge badge-danger"
                                          ng-show="!agent.use_https && !agent.use_autossl">
                                        <?php echo __('HTTP'); ?>
                                    </span>
                                </td>
                            </tr>
                            </tbody>
                        </table>
                        <div class="margin-top-10" ng-show="agents.length == 0">
                            <div class="text-center text-danger italic">
                                <?php echo __('No entries match the selection'); ?>
                            </div>
                        </div>
                        <div class="row margin-top-10 margin-bottom-10">
                            <!-- empty table footer -->
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
</div>
