<?php
// Copyright (C) <2015-present>  <it-novum GmbH>
//
// This file is licensed under the terms of the openITCOCKPIT Enterprise Edition license agreement.
// The license agreement and license key were sent with the order confirmation.
?>
<div id="angularHostStatusDetailsModal" class="modal" role="dialog">
    <div class="modal-dialog modal-lg" role="document">
        <div class="modal-content">
            <div class="modal-header">
                <h5 class="modal-title">
                    <i class="fa fa-cogs"></i>
                    <?php echo __('Host status details'); ?>
                </h5>
                <div class="ml-auto">
                    <button class="btn btn-default btn-xs" ng-click="loadHostDetails(hoststatus)">
                        <i class="fa fa-refresh" ng-class="{'fa-spin': isLoading}"></i>
                        <?php echo __('Refresh'); ?>
                    </button>
                    <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                        <span aria-hidden="true"><i class="fa fa-times"></i></span>
                    </button>
                </div>
            </div>
            <div class="modal-body">
                <div ng-init="flashMshStr='<?php echo __('Command sent successfully. Refresh in 5 seconds'); ?>'"></div>

                <div class="txt-color-white padding-10"
                     ng-class="{'browser-state-green': stateIsUp(), 'browser-state-red': stateIsDown(), 'browser-state-gray': stateIsUnreachable()}"
                     ng-if="hoststatus">

                    <div class="row">
                        <div class="col-xs-12 col-md-2">
                            <strong><?php echo __('Host'); ?></strong>
                        </div>
                        <div class="col-xs-12 col-md-10">
                            <strong>{{hoststatus.host_mapping.display_name}}</strong>
                        </div>
                    </div>

                    <div class="row">
                        <div class="col-xs-12 col-md-2">
                            <?php echo __('State'); ?>
                        </div>
                        <div class="col-xs-12 col-md-10">
                            {{ hoststatus.current_state | hostStatusName }}
                        </div>
                    </div>

                    <div>
                        <div class="row">
                            <div class="col-xs-12 col-md-2">
                                <?php echo __('State since'); ?>
                            </div>
                            <div class="col-xs-12 col-md-10">
                                <span title="{{ hoststatus.last_state_change }}">
                                    {{ hoststatus.last_state_change_for_humans }}
                                </span>
                            </div>
                        </div>
                        <div class="row">
                            <div class="col-xs-12 col-md-2">
                                <?php echo __('Last check'); ?>
                            </div>
                            <div class="col-xs-12 col-md-10">
                                <span title="{{ hoststatus.last_check }}">
                                    {{hoststatus.last_check_in_words}}
                                </span>
                            </div>
                        </div>
                        <div class="row">
                            <div class="col-xs-12 col-md-2">
                                <?php echo __(' Next check'); ?>
                            </div>
                            <div class="col-xs-12 col-md-10">
                                <span title="{{ hoststatus.next_check }}">
                                    {{ hoststatus.next_check_in_words }}
                                </span>
                            </div>
                        </div>
                        <div class="row" ng-show="!hoststatus.is_hardstate">
                            <div class="col-xs-12 col-md-2">
                                <?php echo __('State type'); ?>
                            </div>
                            <div class="col-xs-12 col-md-10">
                                <?php echo __('Soft state'); ?>
                                ({{hoststatus.current_check_attempt}}/{{hoststatus.max_check_attempts}})
                            </div>
                        </div>

                        <div class="row">
                            <div class="col-xs-12 col-md-2">
                                <?php echo __('Output'); ?>
                            </div>
                            <div class="col-xs-12 col-md-10">
                                <div
                                        ng-bind-html="hoststatus.output | trustAsHtml"></div>
                            </div>
                        </div>

                        <div class="row d-flex justify-content-center margin-top-10">
                            <div class="btn-group" role="group" aria-label="Basic example">
                                <button type="button"
                                        class="btn btn-default"
                                        title="<?php echo __('Reset check time'); ?>"
                                        ng-click="rescheduleHost(getObjectsForExternalCommandHost())">
                                    <i class="fa fa-refresh"></i>
                                </button>

                                <button type="button"
                                        class="btn btn-default"
                                        title="<?php echo __('Schedule maintenance'); ?>"
                                        ng-click="hostDowntime(getObjectsForExternalCommandHost())">
                                    <i class="fa fa-power-off"></i>
                                </button>

                                <button type="button"
                                        class="btn btn-default"
                                        title="<?php echo __('Acknowledge host status'); ?>"
                                        ng-show="hoststatus.current_state > 0"
                                        ng-click="acknowledgeHost(getObjectsForExternalCommandHost())">
                                    <i class="fa fa-user"></i>
                                </button>

                                <button type="button"
                                        class="btn btn-default"
                                        title="<?php echo __('Passive transfer check result'); ?>"
                                        ng-click="submitHostResult(getObjectsForExternalCommandHost())">
                                    <i class="fa fa-download"></i>
                                </button>

                                <button type="button"
                                        class="btn btn-default"
                                        title="<?php echo __('Enable flap detection'); ?>"
                                        ng-click="enableHostFlapDetection(getObjectsForExternalCommandHost())"
                                        ng-show="!hoststatus.flap_detection_enabled">
                                    <i class="fa fa-adjust"></i>
                                </button>
                                <button type="button"
                                        class="btn btn-default"
                                        title="<?php echo __('Disable flap detection'); ?>"
                                        ng-click="disableHostFlapDetection(getObjectsForExternalCommandHost())"
                                        ng-show="hoststatus.flap_detection_enabled">
                                    <i class="fa fa-adjust"></i>
                                </button>
                            </div>
                        </div>
                    </div>
                </div>

                <div class="row" ng-show="hoststatus.scheduled_downtime_depth > 0">
                    <div class="col-lg-12 padding-10">
                        <div class="browser-border padding-10" style="width: 100%;">

                            <div class="row">
                                <div class="col-lg-12">
                                    <div>
                                        <h4 class="no-padding">
                                            <i class="fa fa-power-off"></i>
                                            <?php echo __('The host is currently in a planned maintenance period'); ?>
                                        </h4>
                                    </div>
                                    <div class="padding-top-5">
                                        <?php echo __('Downtime was set by'); ?>
                                        <b>{{downtime.author_name}}</b>
                                        <?php echo __('with an duration of'); ?>
                                        <b>{{downtime.duration_for_humans}}</b>.
                                    </div>
                                    <div class="padding-top-5">
                                        <small>
                                            <?php echo __('Start time:'); ?>
                                            {{ downtime.scheduled_start_time }}
                                            <?php echo __('End time:'); ?>
                                            {{ downtime.scheduled_end_time }}
                                        </small>
                                    </div>
                                    <div class="padding-top-5">
                                        <?php echo __('Comment: '); ?>
                                        {{downtime.comment_data}}
                                    </div>
                                </div>

                                <div class="col-lg-12">
                                    <?php if ($this->Acl->hasPermission('cancel_downtime', 'externalcommands')): ?>
                                        <button
                                                class="btn btn-xs btn-danger pull-right"
                                                ng-if="downtime.is_cancellable"
                                                ng-click="confirmHostDowntimeDelete(getObjectForDowntimeDelete())">
                                            <i class="fa fa-trash"></i> <?php echo __('Cancel'); ?>
                                        </button>
                                    <?php endif; ?>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>

                <div class="row" ng-show="hoststatus.problem_has_been_acknowledged">
                    <div class="col-lg-12 padding-10">
                        <div class="browser-border padding-10" style="width: 100%;">
                            <div>
                                <h4 class="no-padding">
                                    <i class="fa fa-user" ng-show="!acknowledgement.is_sticky"></i>
                                    <i class="far fa-user" ng-show="acknowledgement.is_sticky"></i>
                                    <?php echo __('State of host is acknowledged'); ?>
                                    <span ng-show="acknowledgement.is_sticky">
                                        (<?php echo __('Sticky'); ?>)
                                    </span>
                                </h4>
                            </div>
                            <div class="padding-top-5">
                                <?php echo __('Acknowledgement was set by'); ?>
                                <b>{{acknowledgement.author_name}}</b>
                                <?php echo __('at'); ?>
                                {{acknowledgement.entry_time}}
                            </div>
                            <div class="padding-top-5">
                                <?php echo __('Comment: '); ?>
                                <div style="display:inline"
                                     ng-bind-html="acknowledgement.comment_data_html | trustAsHtml"></div>
                            </div>
                        </div>
                    </div>
                </div>


                <div class="row" ng-show="hoststatus.is_flapping">
                    <div class="col-lg-12 padding-10">
                        <div class="browser-border padding-10" style="width: 100%;">
                            <div>
                                <h4 class="no-padding txt-color-orangeDark">
                                    <i class="fa fa-exclamation-triangle"></i>
                                    <?php echo __('The state of this host is currently flapping!'); ?>
                                </h4>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
            <div class="modal-footer">
                <?php if ($this->Acl->hasPermission('browser', 'hosts')): ?>
                    <button type="button" class="btn btn-success"
                            data-dismiss="modal"
                            ui-sref="HostsBrowser({uuid:hoststatus.hostname})">
                        <?php echo __('Open details'); ?>
                    </button>
                <?php endif; ?>
                <button type="button" class="btn btn-default" data-dismiss="modal">
                    <?php echo __('Close'); ?>
                </button>
            </div>
        </div>
    </div>
</div>


<?php if ($this->Acl->hasPermission('cancel_downtime', 'externalcommands')): ?>
    <mass-delete-host-downtimes delete-url="/externalcommands/cancel_downtime"
                                callback="showFlashMsg"></mass-delete-host-downtimes>
<?php endif; ?>
<?php if ($this->Acl->hasPermission('reset_check_time', 'externalcommands')): ?>
    <reschedule-host callback="showFlashMsg"></reschedule-host>
<?php endif; ?>
<?php if ($this->Acl->hasPermission('schedule_maintenance', 'externalcommands')): ?>
    <host-downtime callback="showFlashMsg"></host-downtime>
<?php endif; ?>

<?php if ($this->Acl->hasPermission('acknowledge_status', 'externalcommands')): ?>
    <acknowledge-host callback="showFlashMsg"></acknowledge-host>
<?php endif; ?>

<?php if ($this->Acl->hasPermission('process_check_result', 'externalcommands')): ?>
    <submit-host-result max-check-attempts="{{hoststatus.max_check_attempts}}"
                        callback="showFlashMsg"></submit-host-result>
<?php endif; ?>

<?php if ($this->Acl->hasPermission('flap_detection', 'externalcommands')): ?>
    <enable-host-flap-detection callback="showFlashMsg"></enable-host-flap-detection>
    <disable-host-flap-detection callback="showFlashMsg"></disable-host-flap-detection>
<?php endif; ?>
