<?php
// Copyright (C) <2015-present>  <it-novum GmbH>
//
// This file is licensed under the terms of the openITCOCKPIT Enterprise Edition license agreement.
// The license agreement and license key were sent with the order confirmation.
?>
<ol class="breadcrumb page-breadcrumb">
    <li class="breadcrumb-item">
        <a ui-sref="DashboardsIndex">
            <i class="fa fa-home"></i> <?php echo __('Home'); ?>
        </a>
    </li>
    <li class="breadcrumb-item">
        <?php if ($this->Acl->hasPermission('index', 'services')): ?>
            <a ui-sref="ServicesIndex">
                <i class="fas fa-cogs"></i> <?php echo __('Services'); ?>
            </a>
        <?php else: ?>
            <i class="fas fa-cogs"></i> <?php echo __('Services'); ?>
        <?php endif; ?>
    </li>
    <li class="breadcrumb-item">
        <i class="fa fa-stethoscope"></i> <?php echo __('Details'); ?>
    </li>
</ol>

<servicemenu servicestatus="servicestatus"
             hoststatus="hoststatus"
             showbackbutton="false"
             ng-if="servicestatus && hoststatus">
</servicemenu>

<div ng-init="flashMshStr='<?php echo __('Command sent successfully. Refresh in 5 seconds'); ?>'"></div>

<?php if ($this->Acl->hasPermission('reset_check_time', 'externalcommands')): ?>
    <reschedule-service callback="showFlashMsg"></reschedule-service>
<?php endif; ?>
<?php if ($this->Acl->hasPermission('schedule_maintenance', 'externalcommands')): ?>
    <service-downtime callback="showFlashMsg"></service-downtime>
<?php endif; ?>
<?php if ($this->Acl->hasPermission('process_check_result', 'externalcommands')): ?>
    <submit-service-result max-check-attempts="{{servicestatus.max_check_attempts}}"
                           callback="showFlashMsg"></submit-service-result>
<?php endif; ?>
<?php if ($this->Acl->hasPermission('acknowledge_status', 'externalcommands')): ?>
    <acknowledge-service callback="showFlashMsg"></acknowledge-service>
<?php endif; ?>
<?php if ($this->Acl->hasPermission('flap_detection', 'externalcommands')): ?>
    <enable-service-flap-detection callback="showFlashMsg"></enable-service-flap-detection>
    <disable-service-flap-detection callback="showFlashMsg"></disable-service-flap-detection>
<?php endif; ?>

<?php if ($this->Acl->hasPermission('cancel_downtime', 'externalcommands')): ?>
    <mass-delete-host-downtimes delete-url="/externalcommands/cancel_downtime"
                                callback="showFlashMsg"></mass-delete-host-downtimes>
    <mass-delete-service-downtimes delete-url="/externalcommands/cancel_downtime"
                                   callback="showFlashMsg"></mass-delete-service-downtimes>
<?php endif; ?>

<div class="row">
    <div class="col-xl-12">
        <div id="widget-container" class="panel">
            <div class="panel-hdr">
                <h2>
                    <?php echo __('Services'); ?>
                    <span class="fw-300"><i><?php echo __('details'); ?></i></span>
                </h2>

                <div class="panel-toolbar">

                    <ul class="nav nav-pills border-bottom-0" role="tablist">
                        <li class="nav-item">
                            <a class="nav-link disabled" data-toggle="tab" href="javascript:void(0);" role="tab">
                                UUID: {{ servicestatus.service_description }}
                            </a>
                        </li>
                    </ul>

                    <button class="btn btn-xs btn-default mr-1 shadow-0" ng-click="load()">
                        <i class="fas fa-sync"></i> <?php echo __('Refresh'); ?>
                    </button>
                    <ul class="nav nav-tabs border-bottom-0 nav-tabs-clean flex-column flex-sm-row" role="tablist">
                        <li class="nav-item pointer">
                            <a class="nav-link active" data-toggle="tab" ng-click="selectedTab = 'tab1'"
                               role="tab">
                                <i class="fas fa-info">&nbsp;</i> <?php echo __('Status information'); ?>
                            </a>
                        </li>
                    </ul>
                </div>
            </div>
            <div class="panel-container show">
                <div class="panel-content">
                    <!-- Status information start -->
                    <div ng-show="selectedTab == 'tab1'" class="tab-pane">
                        <!-- status overview for small resolutions -->
                        <div class="d-sm-none"
                             ng-class="{'browser-state-green': stateIsOk(), 'browser-state-yellow': stateIsWarning(), 'browser-state-red': stateIsCritical(), 'browser-state-gray': stateIsUnknown(), 'browser-state-blue': stateIsNotInMonitoring()}"
                             ng-if="servicestatus">
                            <div class="row">
                                <div class="col-6 padding-left-25">
                                    <?php echo __('State'); ?>
                                </div>
                                <div class="col-6">
                                    {{ servicestatus.current_state | serviceStatusName }}
                                </div>
                            </div>

                            <div>
                                <div class="row">
                                    <div class="col-6 padding-left-25">
                                        <?php echo __('State since'); ?>
                                    </div>
                                    <div class="col-6">
                                        {{ servicestatus.last_state_change_for_humans }}
                                    </div>
                                </div>
                                <div class="row">
                                    <div class="col-6 padding-left-25">
                                        <?php echo __('Last check'); ?>
                                    </div>
                                    <div class="col-6">
                                        {{ servicestatus.last_check_in_words }}
                                    </div>
                                </div>
                                <div class="row">
                                    <div class="col-6 padding-left-25">
                                        <?php echo __(' Next check'); ?>
                                    </div>
                                    <div class="col-6">
                                        <span
                                                ng-if="mergedService.active_checks_enabled">
                                            {{ servicestatus.next_check_in_words }}
                                        </span>
                                        <span
                                                ng-if="mergedService.active_checks_enabled == 0">
                                            <?php echo __('n/a'); ?>
                                        </span>
                                    </div>
                                </div>
                                <div class="row" ng-show="servicestatus.isHardstate">
                                    <div class="col-6 padding-left-25">
                                        <?php echo __('State type'); ?>
                                    </div>
                                    <div class="col-6">
                                        <?php echo __('Hard state'); ?>
                                        ({{servicestatus.current_check_attempt}}/{{servicestatus.max_check_attempts}})
                                    </div>
                                </div>
                                <div class="row" ng-show="!servicestatus.isHardstate">
                                    <div class="col-6 padding-left-25">
                                        <?php echo __('State type'); ?>
                                    </div>
                                    <div class="col-6">
                                        <?php echo __('Soft state'); ?>
                                        ({{servicestatus.current_check_attempt}}/{{servicestatus.max_check_attempts}})
                                    </div>
                                </div>

                                <div class="row justify-content-center padding-top-10 padding-bottom-10">
                                    <div class="btn-group" role="group" aria-label="Basic example">
                                        <?php if ($this->Acl->hasPermission('reset_check_time', 'externalcommands')): ?>
                                            <button type="button"
                                                    class="btn btn-default"
                                                    ng-click="reschedule(getObjectsForExternalCommand())">
                                                <i class="fa fa-refresh"></i>
                                            </button>
                                        <?php endif; ?>

                                        <?php if ($this->Acl->hasPermission('schedule_maintenance', 'externalcommands')): ?>
                                            <button type="button"
                                                    class="btn btn-default"
                                                    ng-click="serviceDowntime(getObjectsForExternalCommand())">
                                                <i class="fa fa-power-off"></i>
                                            </button>
                                        <?php endif; ?>

                                        <?php if ($this->Acl->hasPermission('acknowledge_status', 'externalcommands')): ?>
                                            <button type="button"
                                                    class="btn btn-default"
                                                    ng-show="servicestatus.current_state > 0"
                                                    ng-click="acknowledgeService(getObjectsForExternalCommand())">
                                                <i class="fa fa-user"></i>
                                            </button>
                                        <?php endif; ?>

                                        <?php if ($this->Acl->hasPermission('process_check_result', 'externalcommands')): ?>
                                            <button type="button"
                                                    class="btn btn-default"
                                                    ng-click="submitServiceResult(getObjectsForExternalCommand())">
                                                <i class="fa fa-download"></i>
                                            </button>
                                        <?php endif; ?>

                                        <?php if ($this->Acl->hasPermission('flap_detection', 'externalcommands')): ?>
                                            <button type="button"
                                                    class="btn btn-default"
                                                    ng-click="enableServiceFlapDetection(getObjectsForExternalCommand())"
                                                    ng-show="!servicestatus.flap_detection_enabled">
                                                <i class="fa fa-adjust"></i>
                                            </button>
                                            <button type="button"
                                                    class="btn btn-default"
                                                    ng-click="disableServiceFlapDetection(getObjectsForExternalCommand())"
                                                    ng-show="servicestatus.flap_detection_enabled">
                                                <i class="fa fa-adjust"></i>
                                            </button>
                                        <?php endif; ?>
                                    </div>
                                </div>
                            </div>
                        </div>


                        <div class="row">
                            <div
                                    class="col-xs-12 col-sm-6 col-md-7 col-lg-9 padding-bottom-10 padding-left-10 padding-right-10">
                                <div class="row">
                                    <div class="col-12" ng-show="servicestatus.is_flapping">
                                        <div class="alert alert-info fade in">
                                            <i class="fa-fw fa fa-info"></i>
                                            <strong><?php echo __('Flapping!'); ?></strong>
                                            <?php echo __('The state of this host is flapping.'); ?>
                                        </div>
                                    </div>
                                    <div class="col-12" ng-if="servicestatus">

                                        <div class="row">
                                            <div class="col-lg-12">
                                                <h3 class="margin-top-5"><?php echo __('Status overview'); ?></h3>
                                            </div>
                                        </div>

                                        <div class="row" ng-show="servicestatus.scheduled_downtime_depth > 0">
                                            <div class="col-lg-12 margin-bottom-10">
                                                <div class="browser-border padding-10" style="width: 100%;">

                                                    <div class="row">
                                                        <div class="col-lg-12">
                                                            <div>
                                                                <h4 class="no-padding">
                                                                    <i class="fa fa-power-off"></i>
                                                                    <?php echo __('The service is currently in a planned maintenance period'); ?>
                                                                </h4>
                                                            </div>
                                                            <div class="padding-top-5">
                                                                <?php echo __('Downtime was set by'); ?>
                                                                <b>{{downtime.author_name}}</b>
                                                                <?php echo __('with an duration of'); ?>
                                                                <b>{{downtime.duration_for_humans}}</b>.
                                                            </div>
                                                            <div class="padding-top-5">
                                                                <small>
                                                                    <?php echo __('Start time:'); ?>
                                                                    {{ downtime.scheduled_start_time }}
                                                                    <?php echo __('End time:'); ?>
                                                                    {{ downtime.scheduled_end_time }}
                                                                </small>
                                                            </div>
                                                            <div class="padding-top-5">
                                                                <?php echo __('Comment: '); ?>
                                                                {{downtime.comment_data}}
                                                            </div>
                                                        </div>

                                                        <div class="col-lg-12">
                                                            <?php if ($this->Acl->hasPermission('cancel_downtime', 'externalcommands')): ?>
                                                                <button
                                                                        class="btn btn-xs btn-danger float-right"
                                                                        ng-if="downtime.is_cancellable"
                                                                        ng-click="confirmServiceDowntimeDelete(getObjectsForDowntimeDelete())">
                                                                    <i class="fa fa-trash"></i> <?php echo __('Cancel'); ?>
                                                                </button>
                                                            <?php endif; ?>
                                                        </div>
                                                    </div>
                                                </div>
                                            </div>
                                        </div>

                                        <div class="row" ng-show="servicestatus.problem_has_been_acknowledged">
                                            <div class="col-lg-12 margin-bottom-10">
                                                <div class="browser-border padding-10" style="width: 100%;">
                                                    <div>
                                                        <h4 class="no-padding">
                                                            <i class="far fa-user"
                                                               ng-show="!acknowledgement.is_sticky"></i>
                                                            <i class="fas fa-user"
                                                               ng-show="acknowledgement.is_sticky"></i>
                                                            <?php echo __('State of service is acknowledged'); ?>
                                                            <span ng-show="acknowledgement.is_sticky">
                                                        (<?php echo __('Sticky'); ?>)
                                                    </span>
                                                        </h4>
                                                    </div>
                                                    <div class="padding-top-5">
                                                        <?php echo __('Acknowledgement was set by'); ?>
                                                        <b>{{acknowledgement.author_name}}</b>
                                                        <?php echo __('at'); ?>
                                                        {{acknowledgement.entry_time}}
                                                    </div>
                                                    <div class="padding-top-5">
                                                        <?php echo __('Comment: '); ?>
                                                        <div style="display:inline"
                                                             ng-bind-html="acknowledgement.comment_data_html | trustAsHtml"></div>
                                                    </div>
                                                </div>
                                            </div>
                                        </div>

                                        <div class="row" ng-show="hoststatus.current_state > 0">
                                            <div class="col-lg-12 margin-bottom-10">
                                                <div class="alert alert-block alert-info">
                                                    <h4 class="alert-heading">
                                                        <i class="fa fa-exclamation-triangle"></i>
                                                        <?php echo __('Problem with host detected!'); ?>
                                                    </h4>
                                                    <?php if ($this->Acl->hasPermission('browser', 'hosts')): ?>
                                                        <a ui-sref="HostsBrowser({uuid:hoststatus.hostname})">
                                                            {{hoststatus.host_mapping.display_name}}
                                                        </a>
                                                    <?php else: ?>
                                                        {{hoststatus.host_mapping.display_name}}
                                                    <?php endif; ?>
                                                </div>
                                            </div>
                                        </div>

                                        <div class="row" ng-show="hoststatus.scheduled_downtime_depth > 0">
                                            <div class="col-lg-12 margin-bottom-10">
                                                <div class="browser-border padding-10" style="width: 100%;">

                                                    <div class="row">
                                                        <div class="col-lg-12">
                                                            <div>
                                                                <h4 class="no-padding">
                                                                    <i class="fa fa-power-off"></i>
                                                                    <?php echo __('The host of this service is currently in a planned maintenance period'); ?>
                                                                </h4>
                                                            </div>
                                                            <div class="padding-top-5">
                                                                <?php echo __('Downtime was set by'); ?>
                                                                <b>{{hostDowntime.author_name}}</b>
                                                                <?php echo __('with an duration of'); ?>
                                                                <b>{{hostDowntime.duration_for_humans}}</b>.
                                                            </div>
                                                            <div class="padding-top-5">
                                                                <small>
                                                                    <?php echo __('Start time:'); ?>
                                                                    {{ hostDowntime.scheduled_start_time }}
                                                                    <?php echo __('End time:'); ?>
                                                                    {{ hostDowntime.scheduled_end_time }}
                                                                </small>
                                                            </div>
                                                            <div class="padding-top-5">
                                                                <?php echo __('Comment: '); ?>
                                                                {{hostDowntime.comment_data}}
                                                            </div>
                                                        </div>

                                                        <div class="col-lg-12">
                                                            <?php if ($this->Acl->hasPermission('cancel_downtime', 'externalcommands')): ?>
                                                                <button
                                                                        class="btn btn-xs btn-danger float-right"
                                                                        ng-if="hostDowntime.is_cancellable"
                                                                        ng-click="confirmHostDowntimeDelete(getObjectForHostDowntimeDelete())">
                                                                    <i class="fa fa-trash"></i> <?php echo __('Delete'); ?>
                                                                </button>
                                                            <?php endif; ?>
                                                        </div>
                                                    </div>
                                                </div>
                                            </div>
                                        </div>

                                        <div class="row" ng-show="hoststatus.problem_has_been_acknowledged">
                                            <div class="col-lg-12 margin-bottom-10">
                                                <div class="browser-border padding-10" style="width: 100%;">
                                                    <div>
                                                        <h4 class="no-padding">
                                                            <i class="far fa-user"
                                                               ng-show="!hostAcknowledgement.is_sticky"></i>
                                                            <i class="fas fa-user"
                                                               ng-show="hostAcknowledgement.is_sticky"></i>
                                                            <?php echo __('State of host is acknowledged'); ?>
                                                            <span ng-show="hostAcknowledgement.is_sticky">
                                                            (<?php echo __('Sticky'); ?>)
                                                        </span>
                                                        </h4>
                                                    </div>
                                                    <div class="padding-top-5">
                                                        <?php echo __('Acknowledgement was set by'); ?>
                                                        <b>{{hostAcknowledgement.author_name}}</b>
                                                        <?php echo __('at'); ?>
                                                        {{hostAcknowledgement.entry_time}}
                                                    </div>
                                                    <div class="padding-top-5">
                                                        <?php echo __('Comment: '); ?>
                                                        <div style="display:inline"
                                                             ng-bind-html="hostAcknowledgement.comment_data_html | trustAsHtml"></div>
                                                    </div>
                                                </div>
                                            </div>
                                        </div>

                                    </div>

                                    <div class="col-xs-12 col-sm-12 col-md-9">
                                        <table class="table table-bordered">
                                            <tbody>
                                            <tr>
                                                <td>
                                                    <?php echo __('Flap detection'); ?>:
                                                </td>
                                                <td ng-if="servicestatus">
                                                    <span class="badge badge-danger"
                                                          ng-show="servicestatus.flap_detection_enabled">
                                                        <?php echo __('Yes'); ?>
                                                    </span>
                                                    <span class="badge badge-success"
                                                          ng-show="!servicestatus.flap_detection_enabled">
                                                        <?php echo __('No'); ?>
                                                    </span>
                                                </td>
                                            </tr>


                                            <tr>
                                                <td>
                                                    <?php echo __('Active checks enabled'); ?>:
                                                </td>
                                                <td ng-if="servicestatus">
                                                    <span class="badge badge-success"
                                                          ng-show="servicestatus.active_checks_enabled">
                                                        <?php echo __('On'); ?>
                                                    </span>
                                                    <span class="badge badge-danger"
                                                          ng-show="!servicestatus.active_checks_enabled">
                                                        <?php echo __('Off'); ?>
                                                    </span>
                                                </td>
                                            </tr>

                                            <tr ng-show="servicestatus.current_state > 0">
                                                <td>
                                                    <?php echo __('Last time'); ?>
                                                    <span class="badge badge-success" style="margin-right: 2px;">
                                                        <?php echo __('OK'); ?>
                                                    </span>
                                                </td>
                                                <td>
                                                    {{ servicestatus.last_time_ok }}
                                                </td>
                                            </tr>

                                            <tr>
                                                <td>
                                                    <?php echo __('Output'); ?>:
                                                </td>
                                                <td ng-if="servicestatus">
                                                    <div
                                                            class="code-font {{ getServicestatusTextColor(servicestatus.current_state) }}"
                                                            ng-class="serviceStatusTextClass"
                                                            ng-bind-html="servicestatus.output_html | trustAsHtml">
                                                        {{ servicestatus.output }}
                                                    </div>
                                                </td>
                                            </tr>

                                            <tr ng-if="servicestatus.perfdata">
                                                <td>
                                                    <?php echo __('Performance data'); ?>:
                                                </td>
                                                <td>
                                                    <code>{{ servicestatus.perfdata }}</code>
                                                </td>
                                            </tr>
                                            </tbody>
                                        </table>
                                    </div>
                                    <div class="col-xs-12 col-sm-12 col-md-3">
                                        <table class="table table-bordered">
                                            <tr>
                                                <td><?php echo __('Check period'); ?></td>
                                                <td>
                                                    {{servicestatus.timeperiod_mapping.display_name}}
                                                </td>
                                            </tr>

                                            <tr>
                                                <td><?php echo __('Check interval'); ?></td>
                                                <td>
                                                    <span ng-show="servicestatus.active_checks_enabled">
                                                        {{ servicestatus.normal_check_interval_for_humans }}
                                                    </span>
                                                    <span ng-show="!servicestatus.active_checks_enabled">
                                                        <?php echo __('n/a due to passive check'); ?>
                                                    </span>
                                                </td>
                                            </tr>

                                            <tr>
                                                <td><?php echo __('Retry interval'); ?></td>
                                                <td>
                                                    <span ng-show="servicestatus.active_checks_enabled">
                                                        {{ servicestatus.retry_check_interval_for_humans }}
                                                    </span>
                                                    <span ng-show="!servicestatus.active_checks_enabled">
                                                        <?php echo __('n/a due to passive check'); ?>
                                                    </span>
                                                </td>
                                            </tr>
                                        </table>
                                    </div>

                                </div>

                                <div class="row padding-bottom-10" ng-show="servicestatus.long_output_html">
                                    <div class="col-12">
                                        <h5 class="margin-top-5"><?= __('Long output') ?></h5>
                                    </div>
                                    <div class="col-12">
                                        <div class="card bg-light">
                                            <div class="card-body ng-binding"
                                                 ng-bind-html="servicestatus.long_output_html | trustAsHtml"></div>
                                        </div>
                                    </div>
                                </div>

                                <!-- Host state overview table -->
                                <div class="row">
                                    <div class="col-lg-12">
                                        <h3 class="margin-top-5"><?php echo __('Host state overview'); ?></h3>
                                    </div>


                                    <div class="col-xs-12 col-sm-12">
                                        <table class="table table-bordered">
                                            <tr>
                                                <th class="width-130"><?php echo __('Host state'); ?></th>
                                                <th><?php echo __('Host name'); ?></th>
                                                <th><?php echo __('Last state change'); ?></th>
                                            </tr>
                                            <tr>
                                                <td class="text-center">
                                                    <hoststatusicon
                                                            ng-if="hoststatus"
                                                            state="hoststatus.current_state"
                                                            is-flapping="hoststatus.is_flapping"
                                                    ></hoststatusicon>
                                                </td>
                                                <td>
                                                    <?php if ($this->Acl->hasPermission('browser', 'hosts')): ?>
                                                        <a ui-sref="HostsBrowser({uuid:hoststatus.hostname})">
                                                            {{ hoststatus.host_mapping.display_name }}
                                                        </a>
                                                    <?php else: ?>
                                                        {{ hoststatus.host_mapping.display_name }}
                                                    <?php endif; ?>
                                                </td>
                                                <td>
                                                    <span title="{{ hoststatus.last_state_change }}">
                                                        {{ hoststatus.last_state_change_for_humans }}
                                                    </span>
                                                </td>
                                            </tr>
                                        </table>
                                    </div>
                                </div>
                            </div>

                            <div class="col-sm-6 col-md-5 col-lg-3 no-padding d-none d-sm-block"
                                 ng-class="{
                                'browser-state-green': stateIsOk(),
                                'browser-state-yellow': stateIsWarning(),
                                'browser-state-red': stateIsCritical(),
                                'browser-state-gray': stateIsUnknown(),
                                'browser-state-blue': stateIsNotInMonitoring()}"
                                 ng-if="servicestatus">
                                <!-- status box -->
                                <div class="text-center txt-color-white">
                                    <h1 class="font-size-50">
                                        {{ servicestatus.current_state | serviceStatusName }}
                                    </h1>
                                </div>
                                <div>
                                    <div class="text-center txt-color-white">
                                        <div><?php echo __('State since'); ?></div>
                                        <h3 class="margin-top-0" title="{{servicestatus.last_state_change}}">
                                            {{ servicestatus.last_state_change_for_humans }}
                                        </h3>
                                    </div>

                                    <div class="text-center txt-color-white">
                                        <div><?php echo __('Last check'); ?></div>
                                        <h3 class="margin-top-0" title="{{servicestatus.last_check}}">
                                            {{ servicestatus.last_check_in_words }}
                                        </h3>
                                    </div>

                                    <div class="text-center txt-color-white">
                                        <div><?php echo __('Next check'); ?></div>
                                        <h3 title="{{servicestatus.next_check}}">
                                            {{ servicestatus.next_check_in_words }}
                                        </h3>
                                    </div>

                                    <div class="text-center txt-color-white">
                                        <div><?php echo __('State type'); ?></div>
                                        <h3 class="margin-top-0" ng-show="servicestatus.is_hardstate">
                                            <?php echo __('Hard state'); ?>
                                            {{servicestatus.current_check_attempt}}/{{servicestatus.max_check_attempts}}
                                        </h3>

                                        <h3 class="margin-top-0" ng-show="!servicestatus.is_hardstate">
                                            <?php echo __('Soft state'); ?>
                                            ({{servicestatus.current_check_attempt}}/{{servicestatus.max_check_attempts}})
                                        </h3>
                                    </div>

                                    <div>
                                        <?php if ($this->Acl->hasPermission('reset_check_time', 'externalcommands')): ?>
                                            <div class="browser-action"
                                                 ng-click="reschedule(getObjectsForExternalCommand())">
                                                <i class="fa fa-refresh"></i>
                                                <?php echo __('Reset check time '); ?>
                                            </div>
                                        <?php endif; ?>

                                        <?php if ($this->Acl->hasPermission('schedule_maintenance', 'externalcommands')): ?>
                                            <div class="browser-action margin-top-10"
                                                 ng-click="serviceDowntime(getObjectsForExternalCommand())">
                                                <i class="fa fa-power-off"></i>
                                                <?php echo __('Schedule maintenance'); ?>
                                            </div>
                                        <?php endif; ?>

                                        <?php if ($this->Acl->hasPermission('acknowledge_status', 'externalcommands')): ?>
                                            <div class="browser-action margin-top-10"
                                                 ng-show="servicestatus.current_state > 0"
                                                 ng-click="acknowledgeService(getObjectsForExternalCommand())">
                                                <i class="fa fa-user"></i>
                                                <?php echo __('Acknowledge service status'); ?>
                                            </div>
                                        <?php endif; ?>

                                        <?php if ($this->Acl->hasPermission('process_check_result', 'externalcommands')): ?>
                                            <div class="browser-action margin-top-10"
                                                 ng-click="submitServiceResult(getObjectsForExternalCommand())">
                                                <i class="fa fa-download"></i>
                                                <?php echo __('Passive transfer check result'); ?>
                                            </div>
                                        <?php endif; ?>

                                        <?php if ($this->Acl->hasPermission('flap_detection', 'externalcommands')): ?>
                                            <div class="browser-action margin-top-10"
                                                 ng-click="enableServiceFlapDetection(getObjectsForExternalCommand())"
                                                 ng-show="!servicestatus.flap_detection_enabled">
                                                <i class="fa fa-adjust"></i>
                                                <?php echo __('Enable flap detection'); ?>
                                            </div>

                                            <div class="browser-action margin-top-10"
                                                 ng-click="disableServiceFlapDetection(getObjectsForExternalCommand())"
                                                 ng-show="servicestatus.flap_detection_enabled">
                                                <i class="fa fa-adjust"></i>
                                                <?php echo __('Disable flap detection'); ?>
                                            </div>
                                        <?php endif; ?>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
</div>

<!-- Service Graphs -->
<div class="row">
    <div class="col-xl-12">
        <div id="panel-2" class="panel">
            <div class="panel-hdr">
                <h2>
                    <?php echo __('Service'); ?>
                    <span class="fw-300"><i><?php echo __('graphs'); ?></i></span>
                </h2>
                <div class="panel-toolbar">
                    <div class="panel-toolbar">

                        <div class="form-group panelToolbarInput">
                            <div class="custom-control custom-checkbox">
                                <input type="checkbox"
                                       class="custom-control-input"
                                       id="ServiceGraphSmoothInterpolation"
                                       ng-model="graph.smoothInterpolation">
                                <label class="custom-control-label no-margin" for="ServiceGraphSmoothInterpolation">
                                    <?php echo __('Smooth'); ?>
                                </label>
                            </div>
                        </div>

                        <div class="form-group panelToolbarInput">
                            <div class="custom-control custom-checkbox">
                                <input type="checkbox"
                                       class="custom-control-input"
                                       id="ServiceGraphShowDatapoints"
                                       ng-model="graph.showDatapoints">
                                <label class="custom-control-label no-margin" for="ServiceGraphShowDatapoints">
                                    <?php echo __('Show data points'); ?>
                                </label>
                            </div>
                        </div>

                        <div class="form-group panelToolbarInput">
                            <div class="custom-control custom-checkbox">
                                <input type="checkbox"
                                       class="custom-control-input"
                                       id="ServiceGraphAutoreferesh"
                                       ng-model="graph.graphAutoRefresh">
                                <label class="custom-control-label no-margin" for="ServiceGraphAutoreferesh">
                                    <?php echo __('Auto refresh'); ?>
                                </label>
                            </div>
                        </div>
                        <div class="btn-group btn-group-xs panelToolbarInput">
                            <button class="btn btn-default dropdown-toggle waves-effect waves-themed" type="button"
                                    data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
                                <?php echo __('Timerange: '); ?>{{availableTimeranges[currentSelectedTimerange]}}
                            </button>
                            <div class="dropdown-menu" x-placement="bottom-start"
                                 style="position: absolute; will-change: top, left; top: 37px; left: 0px;">

                                <a class="dropdown-item dropdown-item-xs"
                                   ng-repeat="(timerange, timerangeName) in availableTimeranges"
                                   href="javascript:void(0);" ng-click="changeGraphTimespan(timerange)">
                                    {{timerangeName}}
                                </a>
                            </div>
                        </div>

                        <div class="btn-group btn-group-xs panelToolbarInput">
                            <button class="btn btn-default dropdown-toggle waves-effect waves-themed" type="button"
                                    data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
                                <?php echo __('Datasource: '); ?>
                                {{ currentDataSource | limitTo: 15 }}{{currentDataSource.length > 15 ? '...' : ''}}
                            </button>
                            <div class="dropdown-menu dropdown-menu-right" x-placement="bottom-start"
                                 style="position: absolute; will-change: top, left; top: 37px; left: 0px;">

                                <a class="dropdown-item dropdown-item-xs" ng-repeat="dsName in dataSources"
                                   ng-click="changeDataSource(dsName)" href="javascript:void(0);">
                                    {{dsName}}
                                </a>
                            </div>
                        </div>

                        <div class="btn-group btn-group-xs panelToolbarInput">
                            <button class="btn btn-default dropdown-toggle waves-effect waves-themed" type="button"
                                    data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
                                <?php echo __('Aggregation: '); ?>
                                <span ng-show="currentAggregation === 'min'"><?= __('Minimum'); ?></span>
                                <span ng-show="currentAggregation === 'avg'"><?= __('Average'); ?></span>
                                <span ng-show="currentAggregation === 'max'"><?= __('Maximum'); ?></span>
                            </button>
                            <div class="dropdown-menu dropdown-menu-right" x-placement="bottom-start"
                                 style="position: absolute; will-change: top, left; top: 37px; left: 0px;">

                                <a class="dropdown-item dropdown-item-xs"
                                   ng-click="changeAggregation('min')" href="javascript:void(0);">
                                    <?= __('Minimum'); ?>
                                </a>

                                <a class="dropdown-item dropdown-item-xs"
                                   ng-click="changeAggregation('avg')" href="javascript:void(0);">
                                    <?= __('Average'); ?>
                                </a>

                                <a class="dropdown-item dropdown-item-xs"
                                   ng-click="changeAggregation('max')" href="javascript:void(0);">
                                    <?= __('Maximum'); ?>
                                </a>

                            </div>
                        </div>

                        <button class="btn btn-xs btn-default mr-1 shadow-0" ng-click="load()">
                            <i class="fas fa-sync"></i> <?php echo __('Refresh'); ?>
                        </button>
                    </div>
                </div>
            </div>
            <div class="panel-container show">
                <div class="panel-content">
                    <div id="graph_data_tooltip"></div>
                    <div id="graphCanvas" style="height: 300px;"></div>
                </div>
            </div>
        </div>
    </div>
</div>
