<?php
// Copyright (C) <2015-present>  <it-novum GmbH>
//
// This file is licensed under the terms of the openITCOCKPIT Enterprise Edition license agreement.
// The license agreement and license key were sent with the order confirmation.

/**
 * @var \App\View\AppView $this
 * @property \App\View\Helper\AclHelper $Acl
 *
 */
?>
<ol class="breadcrumb page-breadcrumb">
    <li class="breadcrumb-item">
        <a ui-sref="DashboardsIndex">
            <i class="fa fa-home"></i> <?php echo __('Home'); ?>
        </a>
    </li>
    <li class="breadcrumb-item">
        <?php if ($this->Acl->hasPermission('index', 'services')): ?>
            <a ui-sref="ServicesIndex">
                <i class="fas fa-cogs"></i> <?php echo __('Services'); ?>
            </a>
        <?php else: ?>
            <i class="fas fa-cogs"></i> <?php echo __('Services'); ?>
        <?php endif; ?>
    </li>
    <li class="breadcrumb-item">
        <i class="fa fa-stethoscope"></i> <?php echo __('Monitored'); ?>
    </li>
</ol>

<div ng-init="flashMshStr='<?php echo __('Command sent successfully. Refresh in 5 seconds'); ?>'"></div>

<div class="row">
    <div class="col-xl-12">
        <div id="widget-container" class="panel">
            <div class="panel-hdr">
                <h2>
                    <?= __('Services'); ?>
                    <span class="fw-300">
                        <i> <?= __('overview'); ?></i>
                    </span>
                </h2>

                <div class="panel-toolbar">
                    <button class="btn btn-xs btn-default mr-1 shadow-0" ng-click="load()">
                        <i class="fas fa-sync"></i> <?php echo __('Refresh'); ?>
                    </button>
                    <button class="btn btn-xs btn-primary shadow-0" ng-click="triggerFilter()">
                        <i class="fas fa-filter"></i> <?php echo __('Filter'); ?>
                    </button>
                </div>
            </div>

            <div class="panel-container show">
                <div class="panel-content">
                    <!-- Start Filter -->
                    <div class="list-filter card margin-bottom-10" ng-show="showFilter">
                        <div class="card-header">
                            <i class="fa fa-filter"></i> <?php echo __('Filter'); ?>
                        </div>
                        <div class="card-body">
                            <div class="row">
                                <div class="col-xs-12 col-md-6 margin-bottom-10">
                                    <div class="form-group">
                                        <div class="input-group">
                                            <div class="input-group-prepend">
                                                <span class="input-group-text"><i class="fas fa-desktop"></i></span>
                                            </div>
                                            <input type="text" class="form-control form-control-sm"
                                                   placeholder="<?php echo __('Filter by host name'); ?>"
                                                   ng-model="filter_host_name"
                                                   ng-model-options="{debounce: 500}">
                                        </div>
                                    </div>
                                </div>
                                <div class="col-xs-12 col-md-6 margin-bottom-10">
                                    <div class="form-group">
                                        <div class="input-group">
                                            <div class="input-group-prepend">
                                                <span class="input-group-text"><i class="fas fa-filter"></i></span>
                                            </div>
                                            <input type="text" class="form-control form-control-sm"
                                                   placeholder="<?php echo __('Filter by output'); ?>"
                                                   ng-model="filter_output"
                                                   ng-model-options="{debounce: 500}">
                                        </div>
                                    </div>
                                </div>
                                <div class="col-xs-12 col-md-6 margin-bottom-10">
                                    <div class="form-group">
                                        <div class="input-group">
                                            <div class="input-group-prepend">
                                                <span class="input-group-text"><i class="fas fa-cogs"></i></span>
                                            </div>
                                            <input type="text" class="form-control form-control-sm"
                                                   placeholder="<?php echo __('Filter by service name'); ?>"
                                                   ng-model="filter_service_name"
                                                   ng-model-options="{debounce: 500}">
                                        </div>
                                    </div>
                                </div>

                            </div>

                            <div class="row">

                                <div class="col-xs-12 col-lg-3">
                                    <fieldset>
                                        <h5><?php echo __('Servicestatus'); ?></h5>
                                        <div class="form-group">
                                            <div class="custom-control custom-checkbox">
                                                <input type="checkbox"
                                                       id="statusFilterOk"
                                                       class="custom-control-input"
                                                       name="checkbox"
                                                       checked="checked"
                                                       ng-model="stateOk"
                                                       ng-model-options="{debounce: 500}">
                                                <label class="custom-control-label custom-control-label-ok"
                                                       for="statusFilterOk"><?php echo __('Ok'); ?></label>
                                            </div>

                                            <div class="custom-control custom-checkbox">
                                                <input type="checkbox"
                                                       id="statusFilterWarning"
                                                       class="custom-control-input"
                                                       name="checkbox"
                                                       checked="checked"
                                                       ng-model="stateWarning"
                                                       ng-model-options="{debounce: 500}">
                                                <label class="custom-control-label custom-control-label-warning"
                                                       for="statusFilterWarning"><?php echo __('Warning'); ?></label>
                                            </div>
                                            <div class="custom-control custom-checkbox">
                                                <input type="checkbox"
                                                       id="statusFilterCritical"
                                                       class="custom-control-input"
                                                       name="checkbox"
                                                       checked="checked"
                                                       ng-model="stateCritical"
                                                       ng-model-options="{debounce: 500}">
                                                <label class="custom-control-label custom-control-label-critical"
                                                       for="statusFilterCritical"><?php echo __('Critical'); ?></label>
                                            </div>

                                            <div class="custom-control custom-checkbox">
                                                <input type="checkbox"
                                                       id="statusFilterUnknown"
                                                       class="custom-control-input"
                                                       name="checkbox"
                                                       checked="checked"
                                                       ng-model="stateUnknown"
                                                       ng-model-options="{debounce: 500}">
                                                <label class="custom-control-label custom-control-label-unknown"
                                                       for="statusFilterUnknown"><?php echo __('Unknown'); ?></label>
                                            </div>
                                        </div>
                                    </fieldset>
                                </div>

                                <div class="col-xs-12 col-lg-3">
                                    <fieldset>
                                        <h5><?php echo __('Acknowledgements'); ?></h5>
                                        <div class="form-group">
                                            <div class="custom-control custom-checkbox">
                                                <input type="checkbox"
                                                       id="ackFilterAck"
                                                       class="custom-control-input"
                                                       name="checkbox"
                                                       checked="checked"
                                                       ng-model="filter.Servicestatus.acknowledged"
                                                       ng-model-options="{debounce: 500}">
                                                <label class="custom-control-label"
                                                       for="ackFilterAck"><?php echo __('Acknowledge'); ?></label>
                                            </div>

                                            <div class="custom-control custom-checkbox">
                                                <input type="checkbox"
                                                       id="ackFilterNotAck"
                                                       class="custom-control-input"
                                                       name="checkbox"
                                                       checked="checked"
                                                       ng-model="filter.Servicestatus.not_acknowledged"
                                                       ng-model-options="{debounce: 500}">
                                                <label class="custom-control-label"
                                                       for="ackFilterNotAck"><?php echo __('Not acknowledged'); ?></label>
                                            </div>
                                        </div>
                                    </fieldset>
                                </div>

                                <div class="col-xs-12 col-lg-3">
                                    <fieldset>
                                        <h5><?php echo __('Downtimes'); ?></h5>
                                        <div class="form-group smart-form">
                                            <div class="custom-control custom-checkbox">
                                                <input type="checkbox"
                                                       id="downtimwFilterInDowntime"
                                                       class="custom-control-input"
                                                       name="checkbox"
                                                       checked="checked"
                                                       ng-model="filter.Servicestatus.in_downtime"
                                                       ng-model-options="{debounce: 500}">
                                                <label class="custom-control-label"
                                                       for="downtimwFilterInDowntime"><?php echo __('In downtime'); ?></label>
                                            </div>

                                            <div class="custom-control custom-checkbox">
                                                <input type="checkbox"
                                                       id="downtimwFilterNotInDowntime"
                                                       class="custom-control-input"
                                                       name="checkbox"
                                                       checked="checked"
                                                       ng-model="filter.Servicestatus.not_in_downtime"
                                                       ng-model-options="{debounce: 500}">
                                                <label class="custom-control-label"
                                                       for="downtimwFilterNotInDowntime"><?php echo __('Not in downtime'); ?></label>
                                            </div>
                                        </div>
                                    </fieldset>
                                </div>
                            </div>
                            <div class="float-right">
                                <button type="button" ng-click="resetFilter()"
                                        class="btn btn-xs btn-danger">
                                    <?php echo __('Reset Filter'); ?>
                                </button>
                            </div>
                        </div>
                    </div>
                    <!-- End Filter -->

                    <div class="frame-wrap">
                        <table class="table table-striped m-0 table-bordered table-hover table-sm" role="grid">
                            <thead>
                            <tr>
                                <th ng-click="orderBy('Servicestatus.current_state')"
                                    class="cursor-pointer"
                                    colspan="2">
                                    <i class="fa"
                                       ng-class="getSortClass('Servicestatus.current_state')"></i>
                                    <?php echo __('Servicestatus'); ?>
                                </th>

                                <th class="no-sort text-center">
                                    <i class="fa fa-user" title="<?php echo __('is acknowledged'); ?>"></i>
                                </th>

                                <th class="no-sort text-center">
                                    <i class="fa fa-power-off"
                                       title="<?php echo __('is in downtime'); ?>"></i>
                                </th>

                                <th ng-click="orderBy('Servicestatus.active_checks_enabled')"
                                    class="width-40 cursor-pointer">
                                    <i class="fa"
                                       ng-class="getSortClass('Servicestatus.active_checks_enabled')"></i>
                                    <strong title="<?php echo __('Passively transferred service'); ?>">
                                        <?php echo __('P'); ?>
                                    </strong>
                                </th>

                                <th class="no-sort text-center">
                                    <i class="fa fa fa-area-chart"
                                       title="<?php echo __('Grapher'); ?>"></i>
                                </th>

                                <th ng-click="orderBy('ServiceMapping.display_name')" class="cursor-pointer">
                                    <i class="fa" ng-class="getSortClass('ServiceMapping.display_name')"></i>
                                    <?php echo __('Service name'); ?>
                                </th>

                                <th ng-click="orderBy('Servicestatus.last_state_change')"
                                    class="cursor-pointer">
                                    <i class="fa"
                                       ng-class="getSortClass('Servicestatus.last_state_change')"></i>
                                    <?php echo __('State since'); ?>
                                </th>
                                <th ng-click="orderBy('Servicestatus.last_check')" class="cursor-pointer">
                                    <i class="fa" ng-class="getSortClass('Servicestatus.last_check')"></i>
                                    <?php echo __('Last check'); ?>
                                </th>
                                <th ng-click="orderBy('Servicestatus.next_check')" class="cursor-pointer">
                                    <i class="fa" ng-class="getSortClass('Servicestatus.next_check')"></i>
                                    <?php echo __('Next check'); ?>
                                </th>
                                <th ng-click="orderBy('Servicestatus.output')" class="cursor-pointer">
                                    <i class="fa" ng-class="getSortClass('Servicestatus.output')"></i>
                                    <?php echo __('Output'); ?>
                                </th>
                            </tr>
                            </thead>
                            <tbody>
                            <tr ng-repeat-start="service in servicestatus"
                                ng-if="servicestatus[$index-1].hostname !== service.hostname">
                                <td colspan="11">
                                    <hoststatusicon state="service.hoststatus.current_state"
                                                    is-flapping="service.hoststatus.is_flapping"></hoststatusicon>

                                    <?php if ($this->Acl->hasPermission('browser', 'hosts')): ?>
                                        <a ui-sref="HostsBrowser({uuid:service.hostname})" class="padding-left-5 txt-color-blueDark">
                                            {{ service.host_mapping.display_name }}
                                        </a>
                                    <?php else: ?>
                                        <span class="padding-left-5">
                                            {{ service.host_mapping.display_name }}
                                        </span>
                                    <?php endif; ?>
                                    <div class="pull-right padding-right-30">
                                        <i class="far fa-clock"></i>
                                        <?= __('State since'); ?> {{ service.hoststatus.last_state_change }}
                                    </div>
                                </td>
                            </tr>
                            <tr ng-repeat-end="">
                                <td class="width-5">
                                    <?php if ($this->Acl->hasPermission('reset_check_time', 'externalcommands') || $this->Acl->hasPermission('schedule_maintenance', 'externalcommands') || $this->Acl->hasPermission('acknowledge_status', 'externalcommands')): ?>
                                        <input type="checkbox"
                                               ng-model="massChange[service.service_description]">
                                    <?php endif; ?>
                                </td>
                                <td class="text-center">
                                    <servicestatusicon state="service.current_state"
                                                       is-flapping="service.is_flapping"></servicestatusicon>
                                </td>

                                <td class="text-center">
                                    <i class="far fa-user"
                                       ng-show="service.problem_has_been_acknowledged"
                                       ng-if="service.acknowledgement_type == 1"></i>

                                    <i class="fas fa-user"
                                       ng-show="service.problem_has_been_acknowledged"
                                       ng-if="service.acknowledgement_type == 2"
                                       title="<?php echo __('Sticky Acknowledgedment'); ?>"></i>
                                </td>

                                <td class="text-center">
                                    <i class="fa fa-power-off"
                                       ng-show="service.scheduled_downtime_depth > 0"></i>
                                </td>

                                <td class="text-center">
                                    <strong title="<?php echo __('Passively transferred service'); ?>"
                                            ng-hide="service.active_checks_enabled">
                                        <?php echo __('P'); ?>
                                    </strong>
                                </td>

                                <td class="text-center">
                                    <?php if ($this->Acl->hasPermission('browser', 'services')): ?>
                                        <a ui-sref="ServicesBrowser({hostuuid:service.hostname, serviceuuid:service.service_description})"
                                           class="txt-color-blueDark"
                                           ng-mouseenter="mouseenter($event, service.hostname, service.service_description)"
                                           ng-mouseleave="mouseleave()">
                                            <i class="fa fa-lg fa-area-chart">
                                            </i>
                                        </a>
                                    <?php else: ?>
                                        <div
                                                ng-mouseenter="mouseenter($event, service.hostname, service.service_description)"
                                                ng-mouseleave="mouseleave()">
                                            <i class="fa fa-lg fa-area-chart">
                                            </i>
                                        </div>
                                    <?php endif; ?>
                                </td>

                                <td>
                                    <?php if ($this->Acl->hasPermission('browser', 'services')): ?>
                                        <a ui-sref="ServicesBrowser({hostuuid:service.hostname, serviceuuid:service.service_description})">
                                            {{ service.service_mapping.display_name }}
                                        </a>
                                    <?php else: ?>
                                        {{ service.service_mapping.display_name }}
                                    <?php endif; ?>
                                </td>

                                <td>
                                    {{ service.last_state_change }}
                                </td>

                                <td>
                                    {{ service.last_check }}
                                </td>

                                <td>
                                    <span ng-show="service.active_checks_enabled">
                                        {{ service.next_check }}
                                    </span>
                                </td>

                                <td>
                                    <div
                                            ng-bind-html="service.output_html | trustAsHtml"></div>
                                </td>
                            </tr>

                            <tr ng-show="servicestatus.length == 0">
                                <td colspan="11" class="text-center txt-color-red">
                                    <?php echo __('No results found'); ?>
                                </td>
                            </tr>

                            </tbody>
                        </table>

                        <?php if ($this->Acl->hasPermission('reset_check_time', 'externalcommands') || $this->Acl->hasPermission('schedule_maintenance', 'externalcommands') || $this->Acl->hasPermission('acknowledge_status', 'externalcommands')): ?>
                            <div class="row margin-top-10 margin-bottom-10">
                                <div class="col-xs-12 col-md-2 text-muted text-center">
                                    <span ng-show="selectedElements > 0">({{selectedElements}})</span>
                                </div>
                                <div class="col-xs-12 col-md-2">
                                    <span ng-click="selectAll()" class="pointer">
                                        <i class="fas fa-lg fa-check-square"></i>
                                        <?php echo __('Select all'); ?>
                                    </span>
                                </div>
                                <div class="col-xs-12 col-md-2">
                                    <span ng-click="undoSelection()" class="pointer">
                                        <i class="fas fa-lg fa-square"></i>
                                        <?php echo __('Undo selection'); ?>
                                    </span>
                                </div>
                                <div class="btn-group btn-group-sm">
                                    <button class="btn btn-default dropdown-toggle waves-effect waves-themed"
                                            type="button"
                                            data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
                                        <?php echo __('Actions'); ?>
                                    </button>
                                    <div class="dropdown-menu" x-placement="bottom-start">
                                        <?php if ($this->Acl->hasPermission('reset_check_time', 'externalcommands')): ?>
                                            <a class="dropdown-item" href="javascript:void(0);"
                                               ng-click="reschedule(getObjectsForExternalCommand())">
                                                <i class="fa fa-refresh"></i> <?php echo __('Reset check time'); ?>
                                            </a>
                                        <?php endif; ?>

                                        <?php if ($this->Acl->hasPermission('schedule_maintenance', 'externalcommands')): ?>
                                            <a class="dropdown-item" href="javascript:void(0);"
                                               ng-click="serviceDowntime(getObjectsForExternalCommand())">
                                                <i class="fa fa-clock-o"></i> <?php echo __('Set planned maintenance times'); ?>
                                            </a>
                                        <?php endif; ?>

                                        <?php if ($this->Acl->hasPermission('acknowledge_status', 'externalcommands')): ?>
                                            <a class="dropdown-item" href="javascript:void(0);"
                                               ng-click="acknowledgeService(getObjectsForExternalCommand())">
                                                <i class="fa fa-user"></i> <?php echo __('Acknowledge service status'); ?>
                                            </a>
                                        <?php endif; ?>
                                    </div>
                                </div>
                            </div>
                        <?php endif; ?>

                        <scroll scroll="scroll" click-action="changepage" ng-if="scroll"></scroll>
                        <paginator paging="paging" click-action="changepage" ng-if="paging"></paginator>
                        <?php echo $this->element('paginator_or_scroll'); ?>

                        <popover-graph-directive></popover-graph-directive>
                    </div>
                </div>
            </div>
        </div>
    </div>
</div>
<?php if ($this->Acl->hasPermission('reset_check_time', 'externalcommands')): ?>
    <reschedule-service callback="showFlashMsg"></reschedule-service>
<?php endif; ?>
<?php if ($this->Acl->hasPermission('schedule_maintenance', 'externalcommands')): ?>
    <service-downtime callback="showFlashMsg"></service-downtime>
<?php endif; ?>

<?php if ($this->Acl->hasPermission('acknowledge_status', 'externalcommands')): ?>
    <acknowledge-service callback="showFlashMsg"></acknowledge-service>
<?php endif; ?>

