<?php
// Copyright (C) <2015-present>  <it-novum GmbH>
//
// This file is licensed under the terms of the openITCOCKPIT Enterprise Edition license agreement.
// The license agreement and license key were sent with the order confirmation.

use App\View\AppView;

/**
 * @var AppView $this
 */
$SystemConfig = new \App\Lib\SystemConfig();
?>

<div id="particles-js" class="peer peer-greed h-100 pos-r">
    <!-- layout fix -->
</div>

<div
        ng-controller="UsersLoginController"
        class="col-12 col-md-4 peer pX-40 pY-80 h-100 scrollable pos-r login-side-bg" style='min-width: 320px;'>

    <div class="col-12 text-center">
        <img class="img-fluid" src="<?= h($SystemConfig->getLoginLogoPath()) ?>" style="max-height: 230px;"/>
    </div>

    <h4 class="fw-300 c-white mB-40"><?= __('Login') ?></h4>

    <!-- Start login form for username and password (Session and LDAP) -->
    <form ng-submit="submit();" ng-if="!hasValidSslCertificate">
        <div class="form-group">
            <label class="text-normal c-white"><?= __('Username') ?></label>
            <input
                    type="text"
                    class="form-control"
                    placeholder="John Doe"
                    ng-disabled="disableLogin"
                    ng-model="post.username">
        </div>
        <div class="form-group">
            <label class="text-normal c-white"><?= __('Password') ?></label>
            <input
                    type="password"
                    class="form-control"
                    placeholder="Password"
                    ng-disabled="disableLogin"
                    ng-model="post.password">
        </div>
        <div class="form-group">
            <div class="peers ai-c jc-sb fxw-nw">
                <div class="peer">
                    <div class="checkbox checkbox-circle checkbox-info peers ai-c">
                        <input
                                type="checkbox"
                                ng-true-value="1"
                                ng-false-value="0"
                                ng-model="post.remember_me"
                                ng-disabled="disableLogin"
                                id="RememberMeCheckbox"
                                class="peer">
                        <label for="RememberMeCheckbox" class=" peers peer-greed js-sb ai-c">
                            <span class="peer peer-greed"><?= __('Remember Me') ?></span>
                        </label>
                    </div>
                </div>
                <div class="peer">
                    <button
                            type="submit"
                            class="btn btn-primary"
                            ng-disabled="disableLogin">
                        <span>
                            <i class="fa fa-spinner fa-spin" ng-show="disableLogin"></i>
                        </span>
                        <?= __('Login') ?>
                    </button>
                </div>
            </div>
        </div>
    </form>
    <!-- End form login -->

    <!-- Users with valid SSL certificates are always logged in -->
    <div ng-if="hasValidSslCertificate">
        <div class="alert alert-success" role="alert">
            <?= __('Authorization through SSL certificate successfully.') ?>
        </div>

        <div class="form-group">
            <div class="peers ai-c jc-sb fxw-nw">
                <div class="peer">
                </div>
                <div class="peer">
                    <a
                            href="/"
                            class="btn btn-primary">
                        <?= __('Start') ?>
                    </a>
                </div>
            </div>
        </div>
    </div>
    <!-- End certificates login -->

    <?php if ($SystemConfig->getShowLinksInLogin()): ?>
        <div class="float-right" style="padding-top: 100px;">
            <a href="https://openitcockpit.io/" target="_blank" class="btn btn-sm btn-light btn-icon">
                <i class="fa fa-lg fa-globe"></i>
            </a>
            <a href="https://github.com/it-novum/openITCOCKPIT" target="_blank"
               class="btn btn-sm btn-light btn-icon">
                <i class="fab fa-lg fa-github"></i>
            </a>
            <a href="https://twitter.com/openITCOCKPIT" target="_blank" class="btn btn-sm btn-light btn-icon">
                <i class="fab fa-lg fa-twitter"></i>
            </a>
            <a href="https://www.reddit.com/r/openitcockpit" target="_blank" class="btn btn-sm btn-light btn-icon">
                <i class="fab fa-lg fa-reddit"></i>
            </a>
            <a href="https://discord.gg/G8KhxKuQ9G" target="_blank" class="btn btn-sm btn-light btn-icon">
                <i class="fab fa-lg fa-discord"></i>
            </a>
        </div>
    <?php endif; ?>

</div>
