<?php
// Copyright (C) <2015-present>  <it-novum GmbH>
//
// This file is licensed under the terms of the openITCOCKPIT Enterprise Edition license agreement.
// The license agreement and license key were sent with the order confirmation.

?>
<?php

use App\View\Helper\ButtonGroupHelper;

class OitcHeader {

    public function __construct($showstatsinmenu) {

        $this->menuHeaderOpens();

        $this->menuControl();
        $this->menuSearchContentByAngularJsDirective();

        $this->menuStatistics($showstatsinmenu);

        $this->menuHeaderCloses();
    }

    private function menuHeaderOpens() {
        echo '<header id="header" class="page-header" role="banner">';
    }

    private function menuControl() {
        echo '<menu-control></menu-control>';
    }

    private function menuSearchContentByAngularJsDirective(): void {
        echo '<div class="search" top-search=""></div>';
    }

    private function menuStatistics($showstatsinmenu): void {

        $html = '<div class="ml-auto d-flex">';


        $html .= $this->menuNotifications();
        $html .= $this->displayMenuStatisticsIfEnabledInSettings($showstatsinmenu);
        $html .= $this->menuSystemHealth();
        $html .= $this->menuSpinner();
        $html .= $this->menuVersionCheck();
        $html .= $this->menuHeaderClockDisplay();
        $html .= $this->menuHeaderSignOut();

        $html .= '</div>';

        echo $html;
    }

    private function menuNotifications(): string {
        return $this->decorateHeaderHtmlElement('<push-notifications></push-notifications>');
    }

    private function decorateHeaderHtmlElement(string $html): string {
        return '<div class="header-icon">' . PHP_EOL
            . '    ' . $html . PHP_EOL
            . '</div>' . PHP_EOL;
    }

    private function displayMenuStatisticsIfEnabledInSettings($showstatsinmenu): string {
        $html = '';

        if ($showstatsinmenu) {
            $html .= $this->decorateHeaderHtmlElement('<menustats></menustats>');
        }

        return $html;
    }

    private function menuSystemHealth(): string {
        return $this->decorateHeaderHtmlElement('<system-health></system-health>');
    }

    private function menuSpinner(): string {
        return $this->decorateHeaderHtmlElement('<span id="global_ajax_loader">
                    <div class="spinner-border spinner-border-sm" role="status">
                        <span class="sr-only">Loading...</span>
                    </div>
                </span>');
    }

    private function menuVersionCheck(): string {
        return $this->decorateHeaderHtmlElement('<version-check></version-check>');
    }

    private function menuHeaderClockDisplay() {
        return $this->decorateHeaderHtmlElement('<server-time></server-time>');
    }

    private function menuHeaderSignOut(): string {

        $signOutBtnGrpHelper = new ButtonGroupHelper('');
        $signOutBtnGrpHelper->addIconButtonWithHRefFixed('fa fa-sign-out-alt', $this->translate('Sign out'), '/users/logout');

        return $this->decorateHeaderHtmlElement($signOutBtnGrpHelper->getHtml());
    }

    private function translate($singular) {
        return __($singular);
    }

    private function menuHeaderCloses() {
        echo '</header>';
    }
}

$header = new OitcHeader($showstatsinmenu);
?>
