<?php
// Copyright (C) <2015-present>  <it-novum GmbH>
//
// This file is licensed under the terms of the openITCOCKPIT Enterprise Edition license agreement.
// The license agreement and license key were sent with the order confirmation.

namespace App\View\Helper;


interface ButtonGroupHelperInterface {
    public function getHtml(): string;

    public function addIconButton(string $iconCssSelector, string $dataOriginalTitle = ''): ButtonGroupHelperInterface;

    public function addIconButtonWithSRef(string $iconCssSelector, string $dataOriginalTitle = '', string $sRef = '', string $additionalHtmlAttributes = ''): ButtonGroupHelperInterface;

    public function addIconButtonWithHRef(string $iconCssSelector, string $dataOriginalTitle = '', string $hRef = ''): ButtonGroupHelperInterface;

    public function addButton(string $innerHtml, string $cssSelector = 'btn-default'): ButtonGroupHelperInterface;

    public function addButtonWithTooltip(string $innerHtml, string $cssSelector = 'btn-default', $dataOriginalTitle = ''): ButtonGroupHelperInterface;

    public function addButtonWithTogglingMenu(string $iconCssSelector, string $dataOriginalTitle = '', string $htmlMenu = ''): ButtonGroupHelperInterface;

    public function addButtonWithTooltipAndSRef(string $innerHtml, string $cssSelector = 'btn-default', $dataOriginalTitle = '', $href = ''): ButtonGroupHelperInterface;

    public function addButtonWithTooltipAndDisplayConditional(string $innerHtml, string $cssSelector = 'btn-default', string $dataOriginalTitle = '', string $conditional = ''): ButtonGroupHelperInterface;

    public function addRaw(string $html): ButtonGroupHelperInterface;

    public function addIconButtonWithHRefFixed(string $iconCssSelector, string $dataOriginalTitle = '', string $hRef = ''): ButtonGroupHelperInterface;
}
