<?php
// Copyright (C) <2015-present>  <it-novum GmbH>
//
// This file is licensed under the terms of the openITCOCKPIT Enterprise Edition license agreement.
// The license agreement and license key were sent with the order confirmation.
namespace itnovum\openITCOCKPIT\Core;

use itnovum\openITCOCKPIT\Core\ValueObjects\ServiceStates;

class AcknowledgedServiceConditions extends ListSettingsConditions {

    /**
     * @var array
     */
    protected $order = [
        'entry_time' => 'DESC'
    ];

    protected $states = [
        0, 1, 2, 3
    ];

    /**
     * @var string
     */
    protected $serviceUuid;

    /**
     * @var bool
     */
    private $useLimit = true;

    /**
     * @param $serviceUuid
     */
    public function setServiceUuid($serviceUuid) {
        $this->serviceUuid = $serviceUuid;
    }

    /**
     * @return string
     */
    public function getServiceUuid() {
        return $this->serviceUuid;
    }

    /**
     * @param $value
     */
    public function setUseLimit($value) {
        $this->useLimit = (bool)$value;
    }

    /**
     * @return bool
     */
    public function getUseLimit() {
        return $this->useLimit;
    }

    /**
     * @param ServiceStates $ServiceStates
     */
    public function setStates(ServiceStates $ServiceStates) {
        if (sizeof($ServiceStates->asIntegerArray()) == 4) {
            $this->states = [];
            return;
        }

        $this->states = $ServiceStates->asIntegerArray();
    }

}

