<?php
// Copyright (C) <2015-present>  <it-novum GmbH>
//
// This file is licensed under the terms of the openITCOCKPIT Enterprise Edition license agreement.
// The license agreement and license key were sent with the order confirmation.

namespace itnovum\openITCOCKPIT\Core\AngularJS\Request;

use App\Filter\BaseFilter;

class ServiceDowntimesControllerRequest extends AngularRequest {

    /**
     * @var array
     */
    protected $filters = [
        'index' => [
            'like' => [
                'Hosts.name',
                'servicename',
                'DowntimeServices.author_name',
                'DowntimeServices.comment_data'
            ],
            'bool' => [
                'DowntimeServices.was_cancelled'
            ]
        ]
    ];

    public function getIndexFilters() {
        $Filter = new BaseFilter($this->getRequest());
        return $Filter->getConditionsByFilters($this->filters['index']);
    }


    public function hideExpired() {
        if ($this->queryHasField('hideExpired')) {
            return $this->getQueryFieldValue('hideExpired') === 'true' || $this->getQueryFieldValue('hideExpired') === '1';
        }
        return true;
    }

    public function isRunning() {
        if ($this->queryHasField('isRunning')) {
            return $this->getQueryFieldValue('isRunning') === 'true' || $this->getQueryFieldValue('isRunning') === '1';
        }
        return false;
    }
}
