<?php
// Copyright (C) <2015-present>  <it-novum GmbH>
//
// This file is licensed under the terms of the openITCOCKPIT Enterprise Edition license agreement.
// The license agreement and license key were sent with the order confirmation.
namespace itnovum\openITCOCKPIT\Core;

class DowntimeHostConditions extends ListSettingsConditions {

    /**
     * @var array
     */
    protected $order = [
        'DowntimeHosts.scheduled_start_time' => 'DESC'
    ];

    /**
     * @var bool
     */
    protected $hideExpired = false;

    /**
     * @var bool
     */
    protected $isRunning = false;

    /**
     * @var bool
     */
    private $includeCancelledDowntimes = false;

    /**
     * @var array
     */
    private $hostUuids = [];

    /**
     * @param bool $value
     */
    public function setHideExpired($value) {
        $this->hideExpired = (bool)$value;
    }

    /**
     * @return bool
     */
    public function hideExpired() {
        return $this->hideExpired;
    }

    /**
     * @param $value
     */
    public function setIsRunning($value) {
        $this->isRunning = (bool)$value;
    }

    /**
     * @return bool
     */
    public function isRunning() {
        return $this->isRunning;
    }

    /**
     * @param array $uuids
     */
    public function setHostUuid($uuids = []) {
        if (!is_array($uuids)) {
            $uuids = [$uuids];
        }
        $this->hostUuids = $uuids;
    }

    /**
     * @return array
     */
    public function getHostUuids() {
        return $this->hostUuids;
    }

    /**
     * @return bool
     */
    public function hasHostUuids() {
        return !empty($this->hostUuids);
    }

    /**
     * @return bool
     */
    public function includeCancelledDowntimes() {
        return $this->includeCancelledDowntimes;
    }

    /**
     * @param bool $includeCancelledDowntimes
     */
    public function setIncludeCancelledDowntimes($includeCancelledDowntimes) {
        $this->includeCancelledDowntimes = (bool)$includeCancelledDowntimes;
    }
}

