<?php
// Copyright (C) <2015-present>  <it-novum GmbH>
//
// This file is licensed under the terms of the openITCOCKPIT Enterprise Edition license agreement.
// The license agreement and license key were sent with the order confirmation.

declare(strict_types=1);

namespace itnovum\openITCOCKPIT\Core;

use Cake\Error\Debugger;
use Cake\ORM\Query;

class FileDebugger {

    /**
     * @param mixed $data
     * @param string $filename
     */
    public static function dump($data, $filename = '/tmp/debug.log', $wipe = false) {

        $trace = Debugger::trace();
        $file = fopen($filename, 'a+');
        fwrite($file, '************* ' . date('H:i:s - d.m.Y') . ' ************* ' . PHP_EOL);
        fwrite($file, var_export($data, true));
        fwrite($file, PHP_EOL . 'Stack trace' . PHP_EOL);
        fwrite($file, $trace);
        fwrite($file, PHP_EOL . PHP_EOL . PHP_EOL);
        fclose($file);
    }

    /**
     * @param mixed $jsonString
     * @param string $filename
     */
    public static function dumpJson($jsonString, $filename = '/tmp/debug.log', $wipe = false) {

        $trace = Debugger::trace();
        $file = fopen($filename, 'a+');
        fwrite($file, '************* ' . date('H:i:s - d.m.Y') . ' ************* ' . PHP_EOL);
        fwrite($file, json_encode(json_decode($jsonString), JSON_PRETTY_PRINT));
        fwrite($file, PHP_EOL . 'Stack trace' . PHP_EOL);
        fwrite($file, $trace);
        fwrite($file, PHP_EOL . PHP_EOL . PHP_EOL);
        fclose($file);
    }

    /**
     * @param mixed $data
     * @param string $filename
     */
    public static function varExport($data, $filename = '/tmp/debug.log', $wipe = false) {

        $file = fopen($filename, 'a+');
        fwrite($file, '************* ' . date('H:i:s - d.m.Y') . ' ************* ' . PHP_EOL);

        if ($data === null) {
            $data = 'NULL';
        }

        if ($data === true) {
            $data = 'TRUE';
        }

        if ($data === false) {
            $data = 'FALSE';
        }

        $file = fopen($filename, 'a+');
        fwrite($file, '************* ' . date('H:i:s - d.m.Y') . '************* ' . PHP_EOL);
        fwrite($file, var_export($data, true));
        fwrite($file, PHP_EOL);
        fclose($file);
    }

    public static function wipe($filename = '/tmp/debug.log') {
        fclose(fopen($filename, 'w+'));
    }

    public static function query(Query $query, $die = false, $filename = '/tmp/debug.log') {

        $sql = (string)$query;

        $result = \SqlFormatter::format($sql, false);

        $file = fopen($filename, 'a+');
        fwrite($file, '************* SQL query' . date('H:i:s - d.m.Y') . ' ************* ' . PHP_EOL);
        fwrite($file, $result);
        fwrite($file, PHP_EOL . PHP_EOL . PHP_EOL);
        fclose($file);

        if ($die) {
            die('die() in ' . __CLASS__ . ' on line: ' . __LINE__);
        }
    }

    public static function dieQuery(Query $query) {
        $sql = (string)$query;

        $result = \SqlFormatter::format($sql, true);
        echo $result;
        die();
    }
}
