<?php
// Copyright (C) <2015-present>  <it-novum GmbH>
//
// This file is licensed under the terms of the openITCOCKPIT Enterprise Edition license agreement.
// The license agreement and license key were sent with the order confirmation.

namespace itnovum\openITCOCKPIT\Core;


use itnovum\openITCOCKPIT\Core\ValueObjects\HostStates;

class HostcheckConditions extends ListSettingsConditions {

    /**
     * @var array
     */
    protected $order = [
        'Hostchecks.start_time' => 'DESC'
    ];

    protected $states = [
        0, 1, 2
    ];

    /**
     * @var string
     */
    protected $hostUuid;

    /**
     * @param string $hostUuid
     */
    public function setHostUuid($hostUuid) {
        $this->hostUuid = $hostUuid;
    }

    /**
     * @return string
     */
    public function getHostUuid() {
        return $this->hostUuid;
    }

    /**
     * @param HostStates $HostStates
     */
    public function setStates(HostStates $HostStates) {
        if (sizeof($HostStates->asIntegerArray()) == 3) {
            $this->states = [];
            return;
        }

        $this->states = $HostStates->asIntegerArray();
    }

}

