<?php
// Copyright (C) <2015-present>  <it-novum GmbH>
//
// This file is licensed under the terms of the openITCOCKPIT Enterprise Edition license agreement.
// The license agreement and license key were sent with the order confirmation.

namespace itnovum\openITCOCKPIT\Core\Views;


use itnovum\openITCOCKPIT\Core\Servicestatus;

class ServiceStateSummary {

    /**
     * @param array $servicestatusArray array of \itnovum\openITCOCKPIT\Core\Servicestatus objects
     * @param bool $extended show details ('acknowledged', 'in downtime', ...)
     * @return array
     */
    public static function getServiceStateSummary($servicestatusArray, $extended = true) {
        $serviceStateSummary = [
            'state' => [
                0 => 0,
                1 => 0,
                2 => 0,
                3 => 0,
            ],
            'total' => 0
        ];
        if ($extended === true) {
            $serviceStateSummary = [
                'state'        => [
                    0 => 0,
                    1 => 0,
                    2 => 0,
                    3 => 0,
                ],
                'acknowledged' => [
                    0 => 0,
                    1 => 0,
                    2 => 0,
                    3 => 0,
                ],
                'in_downtime'  => [
                    0 => 0,
                    1 => 0,
                    2 => 0,
                    3 => 0,
                ],
                'not_handled'  => [
                    0 => 0,
                    1 => 0,
                    2 => 0,
                    3 => 0,
                ],
                'passive'      => [
                    0 => 0,
                    1 => 0,
                    2 => 0,
                    3 => 0,
                ],
                'total'        => 0
            ];
        }
        if (empty($servicestatusArray)) {
            return $serviceStateSummary;
        }
        foreach ($servicestatusArray as $Servicestatus) {
            /** @var $Servicestatus Servicestatus */
            $serviceStateSummary['state'][$Servicestatus->currentState()]++;
            if ($extended === true) {
                if ($Servicestatus->currentState() > 0) {
                    if ($Servicestatus->isAcknowledged()) {
                        $serviceStateSummary['acknowledged'][$Servicestatus->currentState()]++;
                    } else {
                        $serviceStateSummary['not_handled'][$Servicestatus->currentState()]++;
                    }
                }

                if ($Servicestatus->isInDowntime()) {
                    $serviceStateSummary['in_downtime'][$Servicestatus->currentState()]++;
                }
                if ($Servicestatus->isActiveChecksEnabled() === false) {
                    $serviceStateSummary['passive'][$Servicestatus->currentState()]++;
                }
            }
            $serviceStateSummary['total']++;
        }
        return $serviceStateSummary;
    }

}
