<?php
// Copyright (C) <2015-present>  <it-novum GmbH>
//
// This file is licensed under the terms of the openITCOCKPIT Enterprise Edition license agreement.
// The license agreement and license key were sent with the order confirmation.

namespace itnovum\openITCOCKPIT\Graphite;


use App\Lib\SystemConfig;

class GraphiteConfig {

    /**
     * @var string
     */
    private $host = '127.0.0.1';

    /**
     * @var int
     */
    private $port = 8888;

    /**
     * @var string
     */
    private $graphitePrefix;

    /**
     * @var bool
     */
    private $useHttps = false;

    /**
     * @var bool
     */
    private $useProxy = false;

    /**
     * @var bool
     */
    private $ignoreSslCertificate = true;


    public function __construct() {
        $SystemConfig = new SystemConfig();
        $this->graphitePrefix = $SystemConfig->getGraphitePrefix();
    }

    /**
     * @return string
     */
    public function getHost() {
        return $this->host;
    }

    /**
     * @return int
     */
    public function getPort() {
        return $this->port;
    }

    /**
     * @return string
     */
    public function getGraphitePrefix() {
        return $this->graphitePrefix;
    }

    /**
     * @return bool
     */
    public function isUseHttps() {
        return $this->useHttps;
    }

    /**
     * @return bool
     */
    public function isUseProxy() {
        return $this->useProxy;
    }

    /**
     * @return bool
     */
    public function isIgnoreSslCertificate() {
        return !$this->ignoreSslCertificate;
    }


    public function getBaseUrl() {
        return sprintf(
            '%s%s:%s',
            $this->isUseHttps() ? 'https://' : 'http://',
            $this->host,
            $this->port
        );
    }

}
