angular.module('openITCOCKPIT')
    .controller('HostchecksIndexController', function($scope, $http, $rootScope, $httpParamSerializer, SortService, QueryStringService, $stateParams, $q){

        SortService.setSort(QueryStringService.getValue('sort', 'Hostchecks.start_time'));
        SortService.setDirection(QueryStringService.getValue('direction', 'desc'));
        $scope.currentPage = 1;

        $scope.useScroll = true;

        var now = new Date();

        /*** Filter Settings ***/
        var defaultFilter = function(){
            $scope.filter = {
                Hostchecks: {
                    state: {
                        recovery: false,
                        down: false,
                        unreachable: false
                    },
                    state_types: {
                        soft: false,
                        hard: false
                    },
                    output: ''
                },
                from: date('d.m.Y H:i', now.getTime() / 1000 - (3600 * 24 * 30)),
                to: date('d.m.Y H:i', now.getTime() / 1000 + (3600 * 24 * 30 * 2))
            };
        };
        /*** Filter end ***/

        $scope.init = true;
        $scope.showFilter = false;

        $scope.load = function(){

            var state_type = '';
            if($scope.filter.Hostchecks.state_types.soft ^ $scope.filter.Hostchecks.state_types.hard){
                state_type = 0;
                if($scope.filter.Hostchecks.state_types.hard === true){
                    state_type = 1;
                }
            }
            $q.all([
                $http.get("/hostchecks/index.json", {
                    params: {
                        'angular': true,
                        'scroll': $scope.useScroll,
                        'sort': SortService.getSort(),
                        'page': $scope.currentPage,
                        'direction': SortService.getDirection(),
                        'filter[Hostchecks.hostname]': $stateParams.uuid,
                        'filter[Hostchecks.output]': $scope.filter.Hostchecks.output,
                        'filter[Hostchecks.state][]': $rootScope.currentStateForApi($scope.filter.Hostchecks.state),
                        'filter[Hostchecks.state_type]': state_type,
                        'filter[from]': $scope.filter.from,
                        'filter[to]': $scope.filter.to
                    }
                }),
                $http.get("/hosts/browser.json", {
                    params: {
                        uuid: $stateParams.uuid
                    }
                })
            ]).then(function(results){
                $scope.hostchecks = results[0].data.all_hostchecks;
                $scope.paging = results[0].data.paging;
                $scope.scroll = results[0].data.scroll;

                $scope.hoststatus = results[1].data.hoststatus;

                $scope.init = false;
            }, function errorCallback(result){
                if(result.status === 403){
                    $state.go('403');
                }

                if(result.status === 404){
                    $state.go('404');
                }
            });
        };

        $scope.triggerFilter = function(){
            $scope.showFilter = !$scope.showFilter === true;
        };

        $scope.resetFilter = function(){
            defaultFilter();
        };


        $scope.changepage = function(page){
            if(page !== $scope.currentPage){
                $scope.currentPage = page;
                $scope.load();
            }
        };

        $scope.changeMode = function(val){
            $scope.useScroll = val;
            $scope.load();
        };

        //Fire on page load
        defaultFilter();
        SortService.setCallback($scope.load);

        $scope.$watch('filter', function(){
            $scope.currentPage = 1;
            $scope.load();
        }, true);

        $scope.getColorOfState = function(state){
            if(state === 0){
                return 'success';
            }
            if(state === 1){
                return 'danger';
            }
            if(state === 2){
                return 'secondary';
            }
        };
    });
