angular.module('openITCOCKPIT')
    .controller('StatehistoriesHostController', function($scope, $http, $stateParams, SortService){

        $scope.currentPage = 1;
        $scope.useScroll = true;

        SortService.setSort('state_time');
        SortService.setDirection('desc');

        /** Filter settings **/
        var defaultFilter = function(){
            $scope.stateUp = true;
            $scope.stateDown = true;
            $scope.stateUnreachable = true;
            $scope.current_state = [];
            $scope.filter_output = '';
            $scope.filter_host_name = '';
            $scope.showFilter = false;
        };

        defaultFilter();
        /** End filter Settings **/

        $scope.init = true;

        $scope.triggerFilter = function(){
            $scope.showFilter = !$scope.showFilter === true;
        };

        $scope.resetFilter = function(){
            defaultFilter();
        };

        $scope.load = function(){
            $http.get("/statehistories/host.json", {
                params: {
                    'scroll': $scope.useScroll,
                    'sort': SortService.getSort(),
                    'page': $scope.currentPage,
                    'direction': SortService.getDirection(),
                    'filter[HostStatehistory.hostname]': $stateParams.uuid,
                    'filter[HostStatehistory.state][]': $scope.current_state,
                    'filter[HostStatehistory.output]': $scope.filter_output
                }
            }).then(function(result){
                $scope.hoststatehistory = result.data.hoststatehistory;
                $scope.paging = result.data.paging;
                $scope.scroll = result.data.scroll;
                $scope.init = false;
            });
        };

        $scope.loadHoststatus = function(){
            $http.get("/hosts/index.json", {
                params: {
                    'filter[Hoststatus.hostname]': $stateParams.uuid
                }
            }).then(function(result){
                $scope.hoststatus = result.data.hoststatus[0];
            });
        };

        $scope.changepage = function(page){
            if(page !== $scope.currentPage){
                $scope.currentPage = page;
                $scope.load();
            }
        };

        $scope.changeMode = function(val){
            $scope.useScroll = val;
            $scope.load();
        };

        $scope.$watchGroup(['stateUp', 'stateDown', 'stateUnreachable', 'filter_output'], function(){
            if($scope.init){
                return;
            }
            $scope.current_state = [];
            if($scope.stateUp){
                $scope.current_state.push('up');
            }
            if($scope.stateDown){
                $scope.current_state.push('down');
            }
            if($scope.stateUnreachable){
                $scope.current_state.push('unreachable');
            }
            $scope.load();
        });

        $scope.getColorOfState = function(state){
            if(state === 0){
                return 'success';
            }
            if(state === 1){
                return 'danger';
            }
            if(state === 2){
                return 'secondary';
            }
        };

        SortService.setCallback($scope.load);
        SortService.triggerReload();

        $scope.loadHoststatus();


        if($("[rel=tooltip]").length){
            $("[rel=tooltip]").tooltip();
        }
    });
